Package: preciseTAD
Type: Package
Title: preciseTAD: A machine learning framework for precise TAD
        boundary prediction
Version: 1.22.0
Authors@R: c(
    person("Spiro", "Stilianoudakis", 
        email = "stilianoudasc@vcu.edu", 
        role = c("aut")),
    person("Mikhail", "Dozmorov", 
        email = "mikhail.dozmorov@gmail.com", 
        role = c("aut", "cre")))
Description: preciseTAD provides functions to predict the location of boundaries 
    of topologically associated domains (TADs) and chromatin loops at base-level 
    resolution. As an input, it takes BED-formatted genomic coordinates of 
    domain boundaries detected from low-resolution Hi-C data, and coordinates of 
    high-resolution genomic annotations from ENCODE or other consortia. 
    preciseTAD employs several feature engineering strategies and resampling 
    techniques to address class imbalance, and trains an optimized random forest 
    model for predicting low-resolution domain boundaries. Translated on 
    a base-level, preciseTAD predicts the probability for each base to be 
    a boundary. Density-based clustering and scalable partitioning techniques 
    are used to detect precise boundary regions and summit points. Compared with 
    low-resolution boundaries, preciseTAD boundaries are highly enriched for 
    CTCF, RAD21, SMC3, and ZNF143 signal and more conserved across cell lines. 
    The pre-trained model can accurately predict boundaries in another cell line 
    using CTCF, RAD21, SMC3, and ZNF143 annotation data for this cell line. 
License: MIT + file LICENSE
Depends: R (>= 4.1)
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.1.1
Suggests: knitr, rmarkdown, testthat, BiocCheck, BiocManager, BiocStyle
VignetteBuilder: knitr
Imports: S4Vectors, IRanges, GenomicRanges, randomForest, ModelMetrics,
        e1071, PRROC, pROC, caret, utils, cluster, dbscan, doSNOW,
        foreach, pbapply, stats, parallel, gtools, rCGH
biocViews: Software, HiC, Sequencing, Clustering, Classification,
        FunctionalGenomics, FeatureExtraction
BugReports: https://github.com/dozmorovlab/preciseTAD/issues
URL: https://github.com/dozmorovlab/preciseTAD
git_url: https://git.bioconductor.org/packages/preciseTAD
git_branch: RELEASE_3_23
git_last_commit: dda7c03
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 00:00:14 UTC; biocbuild
Author: Spiro Stilianoudakis [aut],
  Mikhail Dozmorov [aut, cre]
Maintainer: Mikhail Dozmorov <mikhail.dozmorov@gmail.com>

<!-- README.md is generated from README.Rmd. Please edit that file -->

# preciseTAD: A transfer learning framework for 3D domain boundary prediction at base-pair resolution

<!-- [![Travis build
status](https://travis-ci.com/stilianoudakis/preciseTAD.svg?branch=master)](https://travis-ci.com/stilianoudakis/preciseTAD) -->
<!-- badges: start -->

[![Lifecycle:
maturing](https://img.shields.io/badge/lifecycle-maturing-blue.svg)](https://www.tidyverse.org/lifecycle/#maturing)
<!-- badges: end -->

**preciseTAD: A transfer learning framework for 3D domain boundary
prediction at base-pair resolution** Spiro C. Stilianoudakis, Maggie A.
Marshall, Mikhail G. Dozmorov. bioRxiv 2020.09.03.282186; doi:
<https://doi.org/10.1101/2020.09.03.282186>

Predicted preciseTAD boundary points (PTBPs) and regions (PTBRs) for 60
cell lines are available
[here](https://drive.google.com/drive/folders/15Rc6PhrrBjThwE-5dSyNX-ILELaUu6uG?usp=sharing).

## Overview

preciseTAD provides functions to predict the location of boundaries of
topologically associated domains (TADs) and chromatin loops at
base-level resolution. As an input, it takes BED-formatted genomic
coordinates of domain boundaries detected from low-resolution Hi-C data,
and coordinates of high-resolution genomic annotations from ENCODE or
other consortia. preciseTAD employs several feature engineering
strategies and resampling techniques to address class imbalance, and
trains an optimized random forest model for predicting low-resolution
domain boundaries. Translated on a base-level, preciseTAD predicts the
probability for each base to be a boundary. Density-based clustering and
scalable partitioning techniques are used to detect precise boundary
regions and summit points. Compared with low-resolution boundaries,
preciseTAD boundaries are highly enriched for CTCF, RAD21, SMC3, and
ZNF143 signal and more conserved across cell lines. The pre-trained
model can accurately predict boundaries in another cell line using CTCF,
RAD21, SMC3, and ZNF143 annotation data for this cell line.

The main functions (in order of implementation) are:

-   `extractBoundaries()` accepts a 3-column data.frame or matrix with
    the chromosomal coordinates of user-defined domains and outputs the
    unique boundaries. The second and third columns are the domain
    anchor centers.
-   `bedToGRangesList()` accepts a filepath containing BED files
    representing the coordinates of ChIP-seq defined functional genomic
    annotations
-   `createTADdata()` accepts a set of unique boundaries and genomic
    annotations derived from `extractBoundaries()` and
    `bedToGRangesList()`, respectively, to create the data matrix used
    to build a model to predict domain boundary regions
-   `TADrandomForest()` a wrapper of the `randomForest` package which
    implements a random forest binary classification algorithm on domain
    boundary data
-   `preciseTAD()` which leverages a domain boundary prediction model
    (i.e., random forest) and density-based clustering to predict TAD
    boundary coordinates at a base-level resolution

## Installation

`preciseTAD` can be installed from Bioconductor:

``` r
# if (!requireNamespace("BiocManager", quietly=TRUE))
#     install.packages("BiocManager")
# BiocManager::install("preciseTAD")
library(preciseTAD)
#> 
```

The latest version of `preciseTAD` can be directly installed from
Github:

``` r
devtools::install_github("dozmorovlab/preciseTAD", build_vignettes = TRUE)
library(preciseTAD)
```

## Usage

Below is a brief workflow of how to implement `preciseTAD` on binned
data from CHR1 to get precise base pair coordinates of TAD boundaries
for a 10mb section of CHR 22. For more details, including the example
how to use the pre-trained model, see `vignette("preciseTAD")`

First, you need to obtain called TAD boundaries using an established
TAD-caller. As an example, consider the
[Arrowhead](https://github.com/aidenlab/juicer/wiki/Arrowhead)
TAD-caller, a part of the juicer suite of tools developed by the Aiden
Lab. Arrowhead outputs a .txt file with the chromosomal start and end
coordinates of their called TADs. As an example, we have provided
Arrowhead TADs for GM12878 at 5kb resolution.

``` r
data("arrowhead_gm12878_5kb")
head(arrowhead_gm12878_5kb)
#>   V1        V2        V3
#> 1  1  49375000  50805000
#> 2  1  16830000  17230000
#> 3  1 163355000 164860000
#> 4  1 231935000 233400000
#> 5  1 149035000 149430000
#> 6  1   3995000   5505000
```

The unique boundaries for CHR1 and CHR22 can be extracted as:

``` r
bounds <- extractBoundaries(domains.mat = arrowhead_gm12878_5kb, filter = FALSE, CHR = c("CHR1", "CHR22"), resolution = 5000)
bounds
#> GRanges object with 1901 ranges and 0 metadata columns:
#>         seqnames            ranges strand
#>            <Rle>         <IRanges>  <Rle>
#>     787     chr1     815000-815001      *
#>    9196     chr1     890000-890001      *
#>      37     chr1     915000-915001      *
#>    8923     chr1   1005000-1005001      *
#>     275     chr1   1015000-1015001      *
#>     ...      ...               ...    ...
#>    8379    chr22 50815000-50815001      *
#>   16788    chr22 50935000-50935001      *
#>    8382    chr22 50945000-50945001      *
#>   16791    chr22 51060000-51060001      *
#>   16670    chr22 51235000-51235001      *
#>   -------
#>   seqinfo: 22 sequences from an unspecified genome; no seqlengths
```

Next, you will need to download cell line-specific ChIP-seq data in the
form of BED files from
[ENCODE](https://www.encodeproject.org/chip-seq-matrix/?type=Experiment&replicates.library.biosample.donor.organism.scientific_name=Homo%20sapiens&assay_title=TF%20ChIP-seq&status=released).
Once, you have downloaded your preferred list of functional genomic
annotations, store them in a specific file location. These files can
then be converted into a GRangesList object and used for downstream
modeling using the following command:

``` r
path <- "pathToBEDfiles"
tfbsList <- bedToGRangesList(filepath = path, bedList = NULL, bedNames = NULL, pattern = "*.bed", signal = 4)
```

As an example, we have already provided a GRangesList object with a
variety of transcription factor binding sites specific to the GM12878
cell line. Once you load it in, you can see the list of transcription
factors using the following:

``` r
data("tfbsList")
names(tfbsList)
#>  [1] "Gm12878-Atf3-Haib"       "Gm12878-Cfos-Sydh"      
#>  [3] "Gm12878-Cmyc-Uta"        "Gm12878-Ctcf-Broad"     
#>  [5] "Gm12878-Egr1-Haib"       "Gm12878-Ets1-Haib"      
#>  [7] "Gm12878-Gabp-Haib"       "Gm12878-Jund-Sydh"      
#>  [9] "Gm12878-Max-Sydh"        "Gm12878-Mazab85725-Sydh"
#> [11] "Gm12878-Mef2a-Haib"      "Gm12878-Mxi1-Sydh"      
#> [13] "Gm12878-P300-Sydh"       "Gm12878-Pol2-Haib"      
#> [15] "Gm12878-Pu1-Haib"        "Gm12878-Rad21-Haib"     
#> [17] "Gm12878-Rfx5-Sydh"       "Gm12878-Sin3a-Sydh"     
#> [19] "Gm12878-Six5-Haib"       "Gm12878-Smc3-Sydh"      
#> [21] "Gm12878-Sp1-Haib"        "Gm12878-Srf-Haib"       
#> [23] "Gm12878-Taf1-Haib"       "Gm12878-Tr4-Sydh"       
#> [25] "Gm12878-Yy1-Sydh"        "Gm12878-Znf143-Sydh"
```

For the purposes of this example, let’s focus only on CTCF, RAD21, SMC3,
and ZNF143 transcription factors.

``` r
tfbsList_filt <- tfbsList[names(tfbsList) %in% c("Gm12878-Ctcf-Broad", "Gm12878-Rad21-Haib", "Gm12878-Smc3-Sydh", "Gm12878-Znf143-Sydh")]
```

Now, using the “ground-truth” boundaries and the following TFBS, we can
build the data matrix that will be used for predictive modeling. The
following command creates the training data from CHR1 and reserves the
testing data from CHR22. We specify 5kb sized genomic bins (to match the
resolution used to call the original TADs), a distance-type feature
space, and apply random under-sampling (RUS) on the training data only.

``` r
set.seed(123)
tadData <- createTADdata(bounds.GR          = bounds,
                         resolution         = 5000,
                         genomicElements.GR = tfbsList_filt,
                         featureType        = "distance",
                         resampling         = "rus",
                         trainCHR           = "CHR1",
                         predictCHR         = "CHR22"
)
```

We can now implement our machine learning algorithm of choice to predict
TAD-boundary regions. Here, we opt for the random forest algorithm.

``` r
set.seed(123)
tadModel <- TADrandomForest(trainData    = tadData[[1]],
                            testData     = tadData[[2]],
                            tuneParams   = list(mtry = 2, ntree = 500, nodesize = 1),
                            cvFolds      = 3,
                            cvMetric     = "Accuracy",
                            verbose      = TRUE,
                            model        = TRUE,
                            importances  = TRUE,
                            impMeasure   = "MDA",
                            performances = TRUE)
#> Loading required package: lattice
#> Loading required package: ggplot2
#> + Fold1: mtry=2, ntree=500, nodesize=1 
#> - Fold1: mtry=2, ntree=500, nodesize=1 
#> + Fold2: mtry=2, ntree=500, nodesize=1 
#> - Fold2: mtry=2, ntree=500, nodesize=1 
#> + Fold3: mtry=2, ntree=500, nodesize=1 
#> - Fold3: mtry=2, ntree=500, nodesize=1 
#> Aggregating results
#> Fitting final model on full training set
# The model itself
tadModel[[1]]
#> Random Forest 
#> 
#> 3190 samples
#>    4 predictor
#>    2 classes: 'No', 'Yes' 
#> 
#> No pre-processing
#> Resampling: Cross-Validated (3 fold) 
#> Summary of sample sizes: 2126, 2127, 2127 
#> Resampling results:
#> 
#>   MCC        ROC        Sens    Spec       Pos Pred Value  Neg Pred Value
#>   0.4679235  0.7990197  0.7072  0.7598457  0.747661        0.7224703     
#>   Accuracy   Kappa    
#>   0.7335413  0.4670627
#> 
#> Tuning parameter 'mtry' was held constant at a value of 2
#> Tuning
#>  parameter 'ntree' was held constant at a value of 500
#> Tuning
#>  parameter 'nodesize' was held constant at a value of 1

# Variable importances (mean decrease in accuracy)
tadModel[[2]]
#>                 Feature Importance
#> 4 `Gm12878-Znf143-Sydh`   75.98200
#> 3   `Gm12878-Smc3-Sydh`   62.50681
#> 2  `Gm12878-Rad21-Haib`   62.21715
#> 1  `Gm12878-Ctcf-Broad`   32.61855

# Model performance metrics
tadModel[[3]]
#>              Metric  Performance
#> 1                TN 6.400000e+03
#> 2                FN 6.700000e+01
#> 3                FP 2.954000e+03
#> 4                TP 2.390000e+02
#> 5             Total 9.660000e+03
#> 6       Sensitivity 7.810458e-01
#> 7       Specificity 6.841993e-01
#> 8             Kappa 8.363202e-02
#> 9          Accuracy 6.872671e-01
#> 10 BalancedAccuracy 7.326225e-01
#> 11        Precision 7.485124e-02
#> 12              FPR 3.158007e-01
#> 13              FNR 1.036029e-02
#> 14              NPV 9.896397e-01
#> 15              MCC 1.732169e-01
#> 16               F1 1.366105e-01
#> 17              AUC 7.983352e-01
#> 18           Youden 4.652450e-01
#> 19            AUPRC 9.383824e-02
```

Lastly, we take our TAD-boundary region predictive model and use it to
make predictions on a 10mb section of CHR22:35,000,000-45,000,000.

``` r
# Run preciseTAD
set.seed(123)
pt <- preciseTAD( genomicElements.GR = tfbsList_filt,
                  featureType        = "distance",
                  CHR                = "CHR22",
                  chromCoords        = list(35000000, 45000000),
                  tadModel           = tadModel[[1]],
                  threshold          = 1.0,
                  verbose            = FALSE,
                  parallel           = 2,
                  DBSCAN_params      = list(30000, 100),
                  slope              = 5000,
                  genome             = "hg19")

# View preciseTAD predicted boundary coordinates between CHR22:35mb-45mb
pt[[2]]
#> GRanges object with 58 ranges and 0 metadata columns:
#>        seqnames            ranges strand
#>           <Rle>         <IRanges>  <Rle>
#>    [1]    chr22 35337875-35342203      *
#>    [2]    chr22 35413232-35426376      *
#>    [3]    chr22 35543040-35549073      *
#>    [4]    chr22 35620677-35634681      *
#>    [5]    chr22 35740783-35747642      *
#>    ...      ...               ...    ...
#>   [54]    chr22 43261091-43270096      *
#>   [55]    chr22 43425520-43490629      *
#>   [56]    chr22 43774902-43791526      *
#>   [57]    chr22 44272171-44283944      *
#>   [58]    chr22 44382230-44396240      *
#>   -------
#>   seqinfo: 1 sequence from an unspecified genome; no seqlengths
```

#' Function to create a data matrix used for building a predictive model to
#' classify boundary regions from functional genomic elements
#'
#' @param bounds.GR a GRanges object with chromosomal coordinates of TAD
#' boundaries used to identify positive cases (can be obtained using
#' \code{\link{extractBoundaries}}). Required.
#' @param resolution Numeric, the width to bin the genome at, should match the
#' resolution that TADs were called at. Required.
#' @param genomicElements.GR a GRangesList object containing GRanges objects
#' for each ChIP-seq data to leverage in the random forest model (can be
#' obtained using the \code{\link{bedToGRangesList}}). Required.
#' @param featureType Character, controls how the feature space is constructed
#' (one of either "binary" (overlap yes/no), "oc" (overlap counts, the number
#' of overlaps), "op" (overlap percent, the percent of bin width covered by the
#' genomic annotation), or "distance" (log2-transformed distance from the center
#' of the nearest genomic annotation to the center of the bin); default is
#' "distance"). Required.
#' @param resampling Character, controls if and how the data should be
#' resampled to create balanced classes of boundary vs. nonboundary regions (one
#' of either "none" - no re-sampling, "ros" - Random Over-Sampling, "rus" -
#' Random Under-Sampling. Required.
#' @param trainCHR Character vector of chromosomes to use to build the binned
#' data matrix for training. Required.
#' @param predictCHR Character vector of chromosomes to use to build the binned
#' data matrix for testing. Default in NULL, indicating no test data is created.
#'  If trainCHR=predictCHR then a 7:3 split is created.
#' @param genome version of the human genome assembly. Used to filter out
#' bases overlapping centromeric regions. Accepted values - hg19 (default) or 
#' hg38.
#'
#' @return A list object containing two data.frames: 1) the training data, 2)
#' the test data (only if predictCHR is not NULL, otherwise it is NA). "y" is
#' an indicator whether the corresponding bin is a TAD boundary, and the
#' subsequent columns have the association measures between bins and the
#' genomic annotations
#' @export
#'
#' @import IRanges GenomicRanges rCGH
#'
#' @examples
#' # Create training data for CHR21 and testing data for CHR22 with
#' # 5 kb binning, oc-type predictors from 26 different transcription factor
#' # binding sites from the GM12878 cell line, and random under-sampling
#'
#' # Read in ARROWHEAD-called TADs at 5kb
#' data(arrowhead_gm12878_5kb)
#'
#' #Extract unique boundaries
#' bounds.GR <- extractBoundaries(domains.mat = arrowhead_gm12878_5kb,
#'                                filter = FALSE,
#'                                CHR = c("CHR21", "CHR22"),
#'                                resolution = 5000)
#'
#' # Read in GRangesList of 26 TFBS
#' data(tfbsList)
#'
#' tadData <- createTADdata(bounds.GR = bounds.GR,
#'                          resolution = 5000,
#'                          genomicElements.GR = tfbsList,
#'                          featureType = "oc",
#'                          resampling = "rus",
#'                          trainCHR = "CHR21",
#'                          predictCHR = "CHR22")
createTADdata <- function(bounds.GR, resolution, genomicElements.GR, featureType = "distance",
                          resampling, trainCHR, predictCHR = NULL, genome = "hg19") {

    resolution = as.integer(resolution)

    #ESTABLISHING CHROMOSOME-SPECIFIC SEQINFO#

    #LOADING CHROMOSOME LENGTHS#
    if (genome %in% c("hg19", "hg38")) {
        ifelse(genome == "hg19", centromeres <- rCGH::hg19, centromeres <- rCGH::hg38)
        centromeres$chrom <- paste0("CHR", centromeres$chrom)
    } else {
        print("Wrong genome version. Use hg19 or hg38")
        return(NULL)
    }
    
    #ESTABLISHING DATA MATRIX FOR MODELING#

    if (is.null(predictCHR)) {
        # you are not interested in performance therefore no holdout test data is created

        # building training set
        bounds.GR.flank <- flank(bounds.GR[which(as.character(seqnames(bounds.GR)) %in%
                                                     tolower(trainCHR))], width = (resolution/2), both = TRUE)

        data_mat_list <- list()
        outcome_list <- list()
        train_list <- list()

        for (i in seq_len(length(trainCHR))) {
            start <- (resolution/2)
            chrLength <- centromeres$length[centromeres$chrom %in% trainCHR][i]
            centromereStart <- as.integer(centromeres$centromerStart[centromeres$chrom==trainCHR[i]])
            centromereEnd <- as.integer(centromeres$centromerEnd[centromeres$chrom==trainCHR[i]])
            end <- chrLength - (chrLength %% resolution) + resolution/2

            data_mat_list[[i]] <- matrix(nrow=length(seq(start,end-1,resolution)[-which(seq(start,end-1,resolution) %in% c(centromereStart:centromereEnd))]),
                                         ncol=length(genomicElements.GR))

            dat_mat_gr <- GRanges(seqnames = tolower(trainCHR[i]),
                                  IRanges(start = seq(start,end-1,resolution)[-which(seq(start,end-1,resolution) %in% c(centromereStart:centromereEnd))],
                                          width=resolution))

            if (featureType == "distance") {
                # for use of distance type features
                dat_mat_gr <- GRanges(seqnames = tolower(trainCHR[i]), IRanges(start = (start(dat_mat_gr) +
                                                                                            end(dat_mat_gr))/2, width = 1))
                for (k in seq(length(genomicElements.GR))) {
                    d <- distance_func(dat_mat_gr, genomicElements.GR[[k]])
                    data_mat_list[[i]][, k] <- d
                }
                for (h in seq_len(ncol(data_mat_list[[i]]))) {
                    data_mat_list[[i]][, h] <- log(data_mat_list[[i]][, h] + 1, base = 2)
                }
            } else if (featureType == "binary") {
                for (k in seq_len(length(genomicElements.GR))) {
                    cb <- binary_func(dat_mat_gr, genomicElements.GR[[k]])
                    data_mat_list[[i]][, k] <- cb
                }
            } else if (featureType == "oc") {
                for (k in seq_len(length(genomicElements.GR))) {
                    co <- count_func(dat_mat_gr, genomicElements.GR[[k]])
                    data_mat_list[[i]][, k] <- co
                }
            } else if (featureType == "op") {
                for (k in seq_len(length(genomicElements.GR))) {
                    cp <- percent_func(dat_mat_gr, genomicElements.GR[[k]])
                    data_mat_list[[i]][, k] <- cp
                }
            } else {
                cs <- signal_func(dat_mat_gr, genomicElements.GR[[k]])
                data_mat_list[[i]][, k] <- cs
            }

            outcome_list[[i]] <- countOverlaps(GRanges(seqnames = tolower(trainCHR[i]),
                                                       IRanges(start = seq(start,end-1,resolution)[-which(seq(start,end-1,resolution) %in% c(centromereStart:centromereEnd))],
                                                               width = resolution)), bounds.GR.flank)
            outcome_list[[i]] <- ifelse(outcome_list[[i]] >= 1, 1, 0)

            train_list[[i]] <- cbind.data.frame(outcome_list[[i]], as.matrix(data_mat_list[[i]]))
            names(train_list[[i]]) <- c("y", names(genomicElements.GR))
            train_list[[i]]$y <- factor(train_list[[i]]$y)
            levels(train_list[[i]]$y) <- c("No", "Yes")

            if (resampling == "ros") {
                # assign sample indices
                sampids.train <- sample(x = which(train_list[[i]]$y == "Yes"), size = length(which(train_list[[i]]$y ==
                                                                                                       "No")), replace = TRUE)

                train_list[[i]] <- rbind.data.frame(train_list[[i]][which(train_list[[i]]$y ==
                                                                              "No"), ], train_list[[i]][sampids.train, ])

                # Randomly shuffle the data
                train_list[[i]] <- train_list[[i]][sample(nrow(train_list[[i]])),
                ]

            } else if (resampling == "rus") {
                sampids.train <- sample(x = which(train_list[[i]]$y == "No"), size = length(which(train_list[[i]]$y ==
                                                                                                      "Yes")), replace = FALSE)

                train_list[[i]] <- rbind.data.frame(train_list[[i]][which(train_list[[i]]$y ==
                                                                              "Yes"), ], train_list[[i]][sampids.train, ])

                # Randomly shuffle the data
                train_list[[i]] <- train_list[[i]][sample(nrow(train_list[[i]])),
                ]

            # } else if (resampling == "smote") {
            #     train_list[[i]] <- SMOTE(y ~ ., data = train_list[[i]], perc.over = 100,
            #                              perc.under = 200)
            # 
            #     # Randomly shuffle the data
            #     train_list[[i]] <- train_list[[i]][sample(nrow(train_list[[i]])),
            #     ]
            } else {
                train_list[[i]] = train_list[[i]]
            }


        }

        train_list <- do.call("rbind.data.frame", train_list)

    } else if (isTRUE(all.equal(sort(trainCHR), sort(predictCHR)))) {
        # you are training on the same chr(s) that you are predicting on so we build the
        # full datamatrix (including predictor type) and then split the data into
        # training and testing then perform resampling on training set

        bounds.GR.flank <- flank(bounds.GR, width = (resolution/2), both = TRUE)

        data_mat_list <- list()
        outcome_list <- list()
        full_list <- list()
        train_list <- list()
        test_list <- list()

        for (i in seq_len(length(trainCHR))) {
            start <- (resolution/2)
            chrLength <- centromeres$length[centromeres$chrom %in% trainCHR][i]
            centromereStart <- as.integer(centromeres$centromerStart[centromeres$chrom==trainCHR[i]])
            centromereEnd <- as.integer(centromeres$centromerEnd[centromeres$chrom==trainCHR[i]])
            end <- chrLength - (chrLength %% resolution) + resolution/2

            data_mat_list[[i]] <- matrix(nrow=length(seq(start,end-1,resolution)[-which(seq(start,end-1,resolution) %in% c(centromereStart:centromereEnd))]),
                                         ncol=length(genomicElements.GR))

            dat_mat_gr <- GRanges(seqnames = tolower(trainCHR[i]),
                                  IRanges(start = seq(start,end-1,resolution)[-which(seq(start,end-1,resolution) %in% c(centromereStart:centromereEnd))],
                                          width=resolution))

            if (featureType == "distance") {
                # for use of distance type features
                dat_mat_gr <- GRanges(seqnames = tolower(trainCHR[i]), IRanges(start = (start(dat_mat_gr) +
                                                                                            end(dat_mat_gr))/2, width = 1))
                for (k in seq_len(length(genomicElements.GR))) {
                    d <- distance_func(dat_mat_gr, genomicElements.GR[[k]])
                    data_mat_list[[i]][, k] <- d
                }
                for (h in seq_len(ncol(data_mat_list[[i]]))) {
                    data_mat_list[[i]][, h] <- log(data_mat_list[[i]][, h] + 1, base = 2)
                }
            } else if (featureType == "binary") {
                for (k in seq_len(length(genomicElements.GR))) {
                    cb <- binary_func(dat_mat_gr, genomicElements.GR[[k]])
                    data_mat_list[[i]][, k] <- cb
                }
            } else if (featureType == "oc") {
                for (k in seq_len(length(genomicElements.GR))) {
                    co <- count_func(dat_mat_gr, genomicElements.GR[[k]])
                    data_mat_list[[i]][, k] <- co
                }
            } else if (featureType == "op") {
                for (k in seq_len(length(genomicElements.GR))) {
                    cp <- percent_func(dat_mat_gr, genomicElements.GR[[k]])
                    data_mat_list[[i]][, k] <- cp
                }
            }

            outcome_list[[i]] <- countOverlaps(GRanges(seqnames = tolower(trainCHR[i]),
                                                       IRanges(start = seq(start,end-1,resolution)[-which(seq(start,end-1,resolution) %in% c(centromereStart:centromereEnd))],
                                                               width = resolution)), bounds.GR.flank)
            outcome_list[[i]] <- ifelse(outcome_list[[i]] >= 1, 1, 0)

            full_list[[i]] <- cbind.data.frame(outcome_list[[i]], as.matrix(data_mat_list[[i]]))

            names(full_list[[i]]) <- c("y", names(genomicElements.GR))
            full_list[[i]]$y <- factor(full_list[[i]]$y)
            levels(full_list[[i]]$y) <- c("No", "Yes")

            inTrainingSet <- sample(length(full_list[[i]]$y), floor(length(full_list[[i]]$y) *
                                                                        0.7))
            train_list[[i]] <- full_list[[i]][inTrainingSet, ]
            test_list[[i]] <- full_list[[i]][-inTrainingSet, ]

            if (resampling == "ros") {
                # assign sample indices
                sampids.train <- sample(x = which(train_list[[i]]$y == "Yes"), size = length(which(train_list[[i]]$y ==
                                                                                                       "No")), replace = TRUE)

                train_list[[i]] <- rbind.data.frame(train_list[[i]][which(train_list[[i]]$y ==
                                                                              "No"), ], train_list[[i]][sampids.train, ])

                # Randomly shuffle the data
                train_list[[i]] <- train_list[[i]][sample(nrow(train_list[[i]])),
                ]

            } else if (resampling == "rus") {
                sampids.train <- sample(x = which(train_list[[i]]$y == "No"), size = length(which(train_list[[i]]$y ==
                                                                                                      "Yes")), replace = FALSE)

                train_list[[i]] <- rbind.data.frame(train_list[[i]][which(train_list[[i]]$y ==
                                                                              "Yes"), ], train_list[[i]][sampids.train, ])

                # Randomly shuffle the data
                train_list[[i]] <- train_list[[i]][sample(nrow(train_list[[i]])),
                ]

            # } else if (resampling == "smote") {
            #     train_list[[i]] <- SMOTE(y ~ ., data = train_list[[i]], perc.over = 100,
            #                              perc.under = 200)
            # 
            #     # Randomly shuffle the data
            #     train_list[[i]] <- train_list[[i]][sample(nrow(train_list[[i]])),
            #     ]
            } else {
                train_list[[i]] = train_list[[i]]
            }

        }

        train_list <- do.call("rbind.data.frame", train_list)
        test_list <- do.call("rbind.data.frame", test_list)
    } else {
        # you are training on one set of chr(s) and are predicting on another set of
        # chr(s) first build training set on the trainCHR, implement resampling technique
        # then build testing set from the predictCHR, with no resampling technique

        # building training set
        bounds.GR.flank <- flank(bounds.GR[which(as.character(seqnames(bounds.GR)) %in%
                                                     tolower(trainCHR))], width = (resolution/2), both = TRUE)

        data_mat_list <- list()
        outcome_list <- list()
        train_list <- list()

        for (i in seq_len(length(trainCHR))) {
            start <- (resolution/2)
            chrLength <- centromeres$length[centromeres$chrom %in% trainCHR][i]
            centromereStart <- as.integer(centromeres$centromerStart[centromeres$chrom==trainCHR[i]])
            centromereEnd <- as.integer(centromeres$centromerEnd[centromeres$chrom==trainCHR[i]])
            end <- chrLength - (chrLength %% resolution) + resolution/2

            data_mat_list[[i]] <- matrix(nrow=length(seq(start,end-1,resolution)[-which(seq(start,end-1,resolution) %in% c(centromereStart:centromereEnd))]),
                                         ncol=length(genomicElements.GR))

            dat_mat_gr <- GRanges(seqnames = tolower(trainCHR[i]),
                                  IRanges(start = seq(start,end-1,resolution)[-which(seq(start,end-1,resolution) %in% c(centromereStart:centromereEnd))],
                                          width=resolution))

            if (featureType == "distance") {
                # for use of distance type features
                dat_mat_gr <- GRanges(seqnames = tolower(trainCHR[i]), IRanges(start = (start(dat_mat_gr) +
                                                                                            end(dat_mat_gr))/2, width = 1))
                for (k in seq_len(length(genomicElements.GR))) {
                    d <- distance_func(dat_mat_gr, genomicElements.GR[[k]])
                    data_mat_list[[i]][, k] <- d
                }
                for (h in seq_len(ncol(data_mat_list[[i]]))) {
                    data_mat_list[[i]][, h] <- log(data_mat_list[[i]][, h] + 1, base = 2)
                }
            } else if (featureType == "binary") {
                for (k in seq_len(length(genomicElements.GR))) {
                    cb <- binary_func(dat_mat_gr, genomicElements.GR[[k]])
                    data_mat_list[[i]][, k] <- cb
                }
            } else if (featureType == "oc") {
                for (k in seq_len(length(genomicElements.GR))) {
                    co <- count_func(dat_mat_gr, genomicElements.GR[[k]])
                    data_mat_list[[i]][, k] <- co
                }
            } else if (featureType == "op") {
                for (k in seq_len(length(genomicElements.GR))) {
                    cp <- percent_func(dat_mat_gr, genomicElements.GR[[k]])
                    data_mat_list[[i]][, k] <- cp
                }
            }

            outcome_list[[i]] <- countOverlaps(GRanges(seqnames = tolower(trainCHR[i]),
                                                       IRanges(start = seq(start,end-1,resolution)[-which(seq(start,end-1,resolution) %in% c(centromereStart:centromereEnd))],
                                                               width = resolution)), bounds.GR.flank)

            outcome_list[[i]] <- ifelse(outcome_list[[i]] >= 1, 1, 0)

            train_list[[i]] <- cbind.data.frame(outcome_list[[i]], as.matrix(data_mat_list[[i]]))
            names(train_list[[i]]) <- c("y", names(genomicElements.GR))
            train_list[[i]]$y <- factor(train_list[[i]]$y)
            levels(train_list[[i]]$y) <- c("No", "Yes")

            if (resampling == "ros") {
                # assign sample indices
                sampids.train <- sample(x = which(train_list[[i]]$y == "Yes"), size = length(which(train_list[[i]]$y ==
                                                                                                       "No")), replace = TRUE)

                train_list[[i]] <- rbind.data.frame(train_list[[i]][which(train_list[[i]]$y ==
                                                                              "No"), ], train_list[[i]][sampids.train, ])

                # Randomly shuffle the data
                train_list[[i]] <- train_list[[i]][sample(nrow(train_list[[i]])),
                ]

            } else if (resampling == "rus") {
                sampids.train <- sample(x = which(train_list[[i]]$y == "No"), size = length(which(train_list[[i]]$y ==
                                                                                                      "Yes")), replace = FALSE)

                train_list[[i]] <- rbind.data.frame(train_list[[i]][which(train_list[[i]]$y ==
                                                                              "Yes"), ], train_list[[i]][sampids.train, ])

                # Randomly shuffle the data
                train_list[[i]] <- train_list[[i]][sample(nrow(train_list[[i]])),
                ]

            # } else if (resampling == "smote") {
            #     train_list[[i]] <- SMOTE(y ~ ., data = train_list[[i]], perc.over = 100,
            #                              perc.under = 200)
            # 
            #     # Randomly shuffle the data
            #     train_list[[i]] <- train_list[[i]][sample(nrow(train_list[[i]])),
            #     ]
            } else {
                train_list[[i]] = train_list[[i]]
            }


        }

        train_list <- do.call("rbind.data.frame", train_list)

        # building testing set
        bounds.GR.flank.pred <- flank(bounds.GR[which(as.character(seqnames(bounds.GR)) %in%
                                                          tolower(predictCHR))], width = (resolution/2), both = TRUE)

        data_mat_list <- list()
        outcome_list <- list()
        test_list <- list()

        for (i in seq_len(length(predictCHR))) {
            start <- (resolution/2)
            chrLength <- centromeres$length[centromeres$chrom %in% predictCHR][i]
            centromereStart <- as.integer(centromeres$centromerStart[centromeres$chrom==predictCHR[i]])
            centromereEnd <- as.integer(centromeres$centromerEnd[centromeres$chrom==predictCHR[i]])
            end <- chrLength - (chrLength %% resolution) + resolution/2

            data_mat_list[[i]] <- matrix(nrow=length(seq(start,end-1,resolution)[-which(seq(start,end-1,resolution) %in% c(centromereStart:centromereEnd))]),
                                         ncol=length(genomicElements.GR))

            dat_mat_gr <- GRanges(seqnames = tolower(predictCHR[i]),
                                  IRanges(start = seq(start,end-1,resolution)[-which(seq(start,end-1,resolution) %in% c(centromereStart:centromereEnd))],
                                          width=resolution))

            if (featureType == "distance") {
                # for use of distance type features
                dat_mat_gr <- GRanges(seqnames = tolower(predictCHR[i]), IRanges(start = (start(dat_mat_gr) +
                                                                                              end(dat_mat_gr))/2, width = 1))
                for (k in seq_len(length(genomicElements.GR))) {
                    d <- distance_func(dat_mat_gr, genomicElements.GR[[k]])
                    data_mat_list[[i]][, k] <- d
                }
                for (h in seq_len(ncol(data_mat_list[[i]]))) {
                    data_mat_list[[i]][, h] <- log(data_mat_list[[i]][, h] + 1, base = 2)
                }
            } else if (featureType == "binary") {
                for (k in seq_len(length(genomicElements.GR))) {
                    cb <- binary_func(dat_mat_gr, genomicElements.GR[[k]])
                    data_mat_list[[i]][, k] <- cb
                }
            } else if (featureType == "oc") {
                for (k in seq_len(length(genomicElements.GR))) {
                    co <- count_func(dat_mat_gr, genomicElements.GR[[k]])
                    data_mat_list[[i]][, k] <- co
                }
            } else if (featureType == "op") {
                for (k in seq_len(length(genomicElements.GR))) {
                    cp <- percent_func(dat_mat_gr, genomicElements.GR[[k]])
                    data_mat_list[[i]][, k] <- cp
                }
            }

            outcome_list[[i]] <- countOverlaps(GRanges(seqnames = tolower(predictCHR[i]),
                                                       IRanges(start = seq(start,end-1,resolution)[-which(seq(start,end-1,resolution) %in% c(centromereStart:centromereEnd))],
                                                               width = resolution)), bounds.GR.flank.pred)
            outcome_list[[i]] <- ifelse(outcome_list[[i]] >= 1, 1, 0)

            test_list[[i]] <- cbind.data.frame(outcome_list[[i]], as.matrix(data_mat_list[[i]]))
            names(test_list[[i]]) <- c("y", names(genomicElements.GR))
            test_list[[i]]$y <- factor(test_list[[i]]$y)
            levels(test_list[[i]]$y) <- c("No", "Yes")

        }

        test_list <- do.call("rbind.data.frame", test_list)

    }

    if (is.null(predictCHR)) {
        TADdataList <- list(train_list, NA)
    } else {
        TADdataList <- list(train_list, test_list)
    }

    return(TADdataList)
}

context("test-juicer_func")

test_that("Whether juicer_func gives us the same output", {

    data(arrowhead_gm12878_5kb)

    bounds.GR <- extractBoundaries(domains.mat=arrowhead_gm12878_5kb,
                                   filter=FALSE,
                                   CHR=c("CHR21","CHR22"),
                                   resolution=5000)

    data(tfbsList)

    tfbsList_filt <- tfbsList[which(names(tfbsList) %in% c("Gm12878-Ctcf-Broad", "Gm12878-Rad21-Haib", "Gm12878-Smc3-Sydh", "Gm12878-Znf143-Sydh"))]

    set.seed(123)

    tadData <- createTADdata(bounds.GR=bounds.GR,
                             resolution=5000,
                             genomicElements.GR=tfbsList_filt,
                             featureType="distance",
                             resampling="rus",
                             trainCHR="CHR21",
                             predictCHR="CHR22")

    set.seed(123)

    tadModel <- TADrandomForest(trainData=tadData[[1]],
                                testData=tadData[[2]],
                                tuneParams=list(mtry=2,
                                                ntree=500,
                                                nodesize=1),
                                cvFolds=3,
                                cvMetric="Accuracy",
                                verbose=TRUE,
                                model=TRUE,
                                importances=TRUE,
                                impMeasure="MDA",
                                performances=TRUE)

    set.seed(123)

    pt <- preciseTAD(genomicElements.GR=tfbsList_filt,
                     featureType="distance",
                     CHR="CHR22",
                     chromCoords=list(17000000,19000000),
                     tadModel=tadModel[[1]],
                     threshold=1.0,
                     verbose=TRUE,
                     parallel=2,
                     DBSCAN_params=list(10000,3),
                     slope=5000,
                     BaseProbs = FALSE,
                     savetobed = FALSE)

    pt_juice <- juicer_func(pt[[2]])

    expect_equal(nrow(pt_juice), 12)

    expect_equal(ncol(pt_juice), 6)
})

context("test-createTADdata")

test_that("Whether createTADdata gives us the same output", {

    data(arrowhead_gm12878_5kb)
    bounds.GR <- extractBoundaries(domains.mat=arrowhead_gm12878_5kb,
                                   filter=FALSE,
                                   CHR=c("CHR21","CHR22"),
                                   resolution=5000)

    data(tfbsList)

    set.seed(123)

    tadData <- createTADdata(bounds.GR=bounds.GR,
                             resolution=5000,
                             genomicElements.GR=tfbsList,
                             featureType="oc",
                             resampling="rus",
                             trainCHR="CHR21",
                             predictCHR="CHR22")

    expect_equal(nrow(tadData[[1]]), 370)

    expect_equal(nrow(tadData[[2]]), 9660)

})

context("test-preciseTAD")

test_that("Whether preciseTAD gives us the same output", {

    data(arrowhead_gm12878_5kb)

    bounds.GR <- extractBoundaries(domains.mat=arrowhead_gm12878_5kb,
                                   filter=FALSE,
                                   CHR=c("CHR21","CHR22"),
                                   resolution=5000)

    data(tfbsList)

    tfbsList_filt <- tfbsList[which(names(tfbsList) %in% c("Gm12878-Ctcf-Broad", "Gm12878-Rad21-Haib", "Gm12878-Smc3-Sydh", "Gm12878-Znf143-Sydh"))]

    set.seed(123)

    tadData <- createTADdata(bounds.GR=bounds.GR,
                             resolution=5000,
                             genomicElements.GR=tfbsList_filt,
                             featureType="distance",
                             resampling="rus",
                             trainCHR="CHR21",
                             predictCHR="CHR22")

    set.seed(123)

    tadModel <- TADrandomForest(trainData=tadData[[1]],
                                testData=tadData[[2]],
                                tuneParams=list(mtry=2,
                                                ntree=500,
                                                nodesize=1),
                                cvFolds=3,
                                cvMetric="Accuracy",
                                verbose=TRUE,
                                model=TRUE,
                                importances=TRUE,
                                impMeasure="MDA",
                                performances=TRUE)

    set.seed(123)

    # genomicElements.GR=tfbsList_filt; featureType="distance"; CHR="CHR22"; chromCoords=list(17000000,19000000); tadModel=tadModel[[1]]; threshold=0.99; verbose=TRUE; parallel=NULL; DBSCAN_params=list(eps=c(5000), MinPts=c(1000)); slope=5000; genome="hg19"; BaseProbs=FALSE
    pt <- preciseTAD(genomicElements.GR  = tfbsList_filt,
                     featureType         = "distance",
                     CHR                 = "CHR22",
                     chromCoords         = list(17000000,19000000),
                     tadModel            = tadModel[[1]],
                     threshold           = 0.99,
                     verbose             = TRUE,
                     parallel            = NULL,
                     DBSCAN_params       = list(eps = c(5000), 
                                                MinPts = c(1000)),
                     slope               = 5000,
                     genome              = "hg19",
                     BaseProbs           = FALSE,
                     savetobed           = FALSE)

    expect_equal(width(pt$PTBR)[1], 13752)

    expect_equal(pt$Summaries$PTBRWidth$median, 11475)

    expect_equal(pt$Summaries$PTBRCoverage$median, 0.3979696)

    expect_equal(length(pt$PTBP), 14)

    expect_equal(IRanges::start(pt$PTBP)[1], 17398701)
})

context("test-TADrfe")

test_that("Whether TADrfe gives us the same output", {

    data(arrowhead_gm12878_5kb)

    bounds.GR <- extractBoundaries(domains.mat=arrowhead_gm12878_5kb,
                                   filter=FALSE,
                                   CHR="CHR22",
                                   resolution=5000)

    data(tfbsList)

    set.seed(123)

    tadData <- createTADdata(bounds.GR=bounds.GR,
                             resolution=5000,
                             genomicElements.GR=tfbsList,
                             featureType="oc",
                             resampling="rus",
                             trainCHR="CHR22",
                             predictCHR=NULL)

    set.seed(123)

    RFEres <- TADrfe(trainData=tadData[[1]],
                     tuneParams=list(ntree=100,
                                     nodesize=1),
                     cvFolds=5,
                     cvMetric="Accuracy",
                     verbose=TRUE)

    expect_equal(round(max(RFEres[[1]]$Accuracy),3), 0.642)

    expect_equal(round(mean(RFEres[[2]]$Overall),3), 5.058)

})

context("test-TADrandomForest")

test_that("Whether TADrandomForest gives us the same output", {

    data(arrowhead_gm12878_5kb)

    bounds.GR <- extractBoundaries(domains.mat=arrowhead_gm12878_5kb,
                                   filter=FALSE,
                                   CHR=c("CHR21","CHR22"),
                                   resolution=5000)

    data(tfbsList)

    set.seed(123)

    tadData <- createTADdata(bounds.GR=bounds.GR,
                             resolution=5000,
                             genomicElements.GR=tfbsList,
                             featureType="distance",
                             resampling="rus",
                             trainCHR="CHR21",
                             predictCHR="CHR22")

    set.seed(123)

    tadModel <- TADrandomForest(trainData=tadData[[1]],
                                testData=tadData[[2]],
                                tuneParams=list(mtry=ceiling(seq.int(2,ncol(tadData[[1]])-1,length.out = 10)),
                                                ntree=500,
                                                nodesize=1),
                                cvFolds=3,
                                cvMetric="Accuracy",
                                verbose=TRUE,
                                model=TRUE,
                                importances=TRUE,
                                impMeasure="MDA",
                                performances=TRUE)

    expect_equal(tadModel[[1]]$bestTune$mtry, 2)

    expect_equal(round(tadModel[[2]]$Importance[which(tadModel[[2]]$Feature=="`Gm12878-Ctcf-Broad`")],3), 17.528)

    expect_equal(round(tadModel[[3]]$Performance[which(tadModel[[3]]$Metric=="BalancedAccuracy")],3), 0.759)
})

#' Helper function used to create count overlap type feature space
#'
#' @param binned_data_gr A GRanges object
#' @param annot_data_gr A Granges object
#'
#' @return A vector of counts enumerating the number of overlaps
#'
#' @import IRanges GenomicRanges
#'
count_func <- function(binned_data_gr, annot_data_gr) {

    # Finding the total number of overlaps between genomic bins and the specific
    # genomic annotation
    count_total <- countOverlaps(binned_data_gr, annot_data_gr)

    return(count_total)
}

#' Helper function used to create percent overlap type feature space
#'
#' @param binned_data_gr A GRanges object
#' @param annot_data_gr A Granges object
#'
#' @return A vector of proportions indicating the percentage of overlap
#'
#' @import IRanges GenomicRanges
#'
percent_func <- function(binned_data_gr, annot_data_gr) {

    count_percent <- numeric(length(binned_data_gr))

    # Finding the total number of overlaps between genomic bins and the specific
    # genomic annotation
    c <- countOverlaps(binned_data_gr, annot_data_gr)

    # places where c=0 denotes no overlap places where c>0 denotes some type of
    # overlap, could be partial or within

    # for c=0 assign percent overlap as 0
    count_percent[which(c == 0)] <- 0

    # for c=1:
    count_percent[which(c == 1)] <- width(pintersect(findOverlapPairs(annot_data_gr,
                                                                      binned_data_gr[which(c == 1)])))/(width(binned_data_gr[1]))

    # for c>1: iterate through all bins with multiple overlaps with the annotation of
    # interest find how many and which annotations overlap within each iterate
    # calculate the width of each overlap sum the total widths and divide by bin
    # width bins with some type of overlap
    mo <- which(c > 1)
    count_percent[mo] <- unlist(lapply(lapply(lapply(mo, function(x) {
        width(pintersect(findOverlapPairs(annot_data_gr, binned_data_gr[x])))
    }), sum), function(x) {
        x/width(binned_data_gr[1])
    }))

    return(count_percent)
}

#' Helper function used to create binary overlap type feature space
#'
#' @param binned_data_gr A GRanges object
#' @param annot_data_gr A Granges object
#'
#' @return An indicator vector for whether or not an overlap occured
#'
#' @import IRanges GenomicRanges
#'
binary_func <- function(binned_data_gr, annot_data_gr) {

    # Finding the total number of overlaps between genomic bins and the specific
    # genomic annotation
    count_binary <- countOverlaps(binned_data_gr, annot_data_gr)

    # Binarizing the overlap (1 or 0)
    count_binary <- ifelse(count_binary > 0, 1, 0)

    return(count_binary)
}

#' Domain data from ARROWHEAD TAD-caller for GM12878 at 5 kb
#'
#' A data frame with 3 columns and 8409 rows
#' \describe{
#' \item{V1}{The chromosome number}
#' \item{V2}{The start coordinate of the TAD}
#' \item{V3}{The end coordinate of the TAD}
#' }
#'
#' @source Data from Rao SS, Huntley MH, Durand NC, Stamenova EK et al.
#' A 3D map of the human genome at kilobase resolution reveals principles
#' of chromatin looping. Cell 2014 Dec 18;159(7):1665-80. PMID: 25497547.
#' Available at
#' \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE63525}
#' @return A data.frame
#'
"arrowhead_gm12878_5kb"

#' Function to create a GRangesList object from functional genomic annotation
#' data in the form of BED files
#'
#' @param filepath Character describing the path to the folder containing the
#' BED files of functional genomic annotations. This is ignored if bedList is
#' specified.
#' @param bedList A list object containing the bed data as data frames to be
#' converted into a GRangesList. The data frames must include at least
#' chromosome, start, and end coordinates as the first 3 columns. Default is
#' NULL.
#' @param bedNames A character vector to provide names to the GRangesList,
#' should be in the order of bedList. Default is NULL.
#' @param pattern Character describing the pattern of the files for the
#' functional genomic annotations. Default is "*.bed".
#' @param signal The column number in the BED files that denotes coverage 
#' strength. Must be the same for all files. Default is NULL indicating to no 
#' coverage value is to be used.
#'
#' @return A \code{GRangesList} object where each entry is a \code{GRanges}
#' object specific to each BED file in the path provided
#' @export
#'
#' @importFrom utils read.table
#' @import IRanges GenomicRanges
#'
#' @examples
#' #set path
#' path <- system.file("extdata", package = "preciseTAD")
#' #contains 2 BED files representing YY1 and NFYA
#' #transcription factor binding sites for GM12878
#' tfbsList <- bedToGRangesList(filepath = path, bedList=NULL, bedNames=NULL,
#' pattern = "*.bed", signal=NULL)
bedToGRangesList <- function(filepath, bedList=NULL, bedNames=NULL, 
                             pattern = "*.bed", signal = NULL) {

    #CREATING GRangesList#

    annots_gr_list <- GRangesList()
    # if(grepl(paste0(names, collapse = '|'), list.files(filepath)))

    if(is.null(bedList)) {
        for (i in seq_len(length(list.files(filepath, pattern = pattern)))) {
            dat <- read.table(paste0(filepath, "/", list.files(filepath, pattern = pattern)[i]),
                              header = FALSE)

            annots_gr_list[[i]] <- GRanges(seqnames = dat$V1, IRanges(start = dat$V2,
                                                                      end = dat$V3))

            if (!(is.null(signal))) {
                mcols(annots_gr_list[[i]])$coverage <- dat[, signal]
            }

        }

        names(annots_gr_list) <- gsub(pattern, "", list.files(filepath, pattern = pattern))

    } else {
        for(i in seq_len(length(bedList))) {
            annots_gr_list[[i]] <- GRanges(seqnames = bedList[[i]][,1],
                                           IRanges(start = bedList[[i]][,2],
                                                   end = bedList[[i]][,3]))

            if (!(is.null(signal))) {
                mcols(annots_gr_list[[i]])$coverage <- bedList[[i]][,signal]
            }
        }

        names(annots_gr_list) <- bedNames
    }

    return(annots_gr_list)
}

context("test-bedToGRangesList")

test_that("Whether bedToGRangesList gives us the same output", {

    path = system.file("extdata", package = "preciseTAD")

    tfbsList <- bedToGRangesList(filepath=path, bedList=NULL, bedNames=NULL,
                                 pattern = "*.bed", signal=4)

    expect_equal(length(tfbsList[[1]]), 1841)

    expect_equal(length(tfbsList[[2]]), 2077)

})

#' A wrapper function passed to \code{caret::rfe} to apply recursive feature
#' elimination (RFE) on binned domain data as a feature reduction technique for
#' random forests. Backward elimination is performed from p down to 2, by
#' powers of 2, where p is the number of features in the data.
#'
#' @param trainData Data frame, the binned data matrix to built a random forest
#' classifiers (can be obtained using \code{\link{createTADdata}}). Required.
#' @param tuneParams List, providing \code{ntree} and \code{nodesize}
#' parameters to feed into \code{\link{randomForest}}. Required.
#' @param cvFolds Numeric, number of k-fold cross-validation to perform.
#' Required.
#' @param cvMetric Character, performance metric to use to choose optimal
#' tuning parameters (one of either "Kappa", "Accuracy", "MCC","ROC","Sens",
#' "Spec", "Pos Pred Value", "Neg Pred Value"). Default is "Accuracy".
#' @param verbose Logical, controls whether or not details regarding modeling
#' should be printed out. Default is TRUE.
#'
#' @return A list containing: 1) the performances extracted at each of the k
#' folds and, 2) Variable importances among the top features at each step of
#' RFE. For 1) `Variables` - the best subset of features to consider at each
#' iteration, `MCC` (Matthews Correlation Coefficient), `ROC` (Area under the
#' receiver operating characteristic curve), `Sens` (Sensitivity), `Spec`
#' (Specificity), `Pos Pred Value` (Positive predictive value), `Neg Pred Value`
#' (Negative predictive value), `Accuracy`, and the corresponding standard
#' deviations across the cross-folds. For 2) `Overall` - the variable
#' importance, `var` - the feature name, `Variables` - the number of features
#' that were considered at each cross-fold, and `Resample` - the cross-fold
#' @export
#'
#' @importFrom ModelMetrics mcc
#' @import randomForest caret e1071
#'
#' @examples
#' # Read in ARROWHEAD-called TADs at 5kb
#' data(arrowhead_gm12878_5kb)
#'
#' #Extract unique boundaries
#' bounds.GR <- extractBoundaries(domains.mat = arrowhead_gm12878_5kb,
#'                                filter = FALSE,
#'                                CHR = "CHR22",
#'                                resolution = 5000)
#'
#' # Read in GRangesList of 26 TFBS
#' data(tfbsList)
#'
#' # Create the binned data matrix for CHR22 using:
#' # 5 kb binning,
#' # oc-type predictors from 26 different TFBS from the GM12878 cell line, and
#' # random under-sampling
#' tadData <- createTADdata(bounds.GR = bounds.GR,
#'                          resolution = 5000,
#'                          genomicElements.GR = tfbsList,
#'                          featureType = "oc",
#'                          resampling = "rus",
#'                          trainCHR = "CHR22",
#'                          predictCHR = NULL)
#'
#' # Perform RFE for fully grown random forests with 100 trees using 5-fold CV
#' # Evaluate performances using accuracy
#' rfe_res <- TADrfe(trainData = tadData[[1]],
#'                   tuneParams = list(ntree = 100, nodesize = 1),
#'                   cvFolds = 5,
#'                   cvMetric = "Accuracy",
#'                   verbose = TRUE)
TADrfe <- function(trainData, tuneParams = list(ntree = 500, nodesize = 1),
                   cvFolds = 5, cvMetric = "Accuracy", verbose = FALSE) {

    #Establishing summary function#

    predictiveValues <- function(data, lev = NULL, model = NULL, ...) {
        PPVobj <- posPredValue(data[, "pred"], data[, "obs"])
        NPVobj <- negPredValue(data[, "pred"], data[, "obs"])
        out <- c(PPVobj, NPVobj)
        # out <- c(NPVobj)
        names(out) <- c("Pos Pred Value", "Neg Pred Value")
        # names(out) <- c('Neg Pred Value')
        out
    }

    allSummary <- function(data, lev = NULL, model = NULL) {
        lvls <- levels(data$obs)

        # mcc
        mcc <- mcc(ifelse(data$obs == lev[2], 0, 1), data[, lvls[1]], cutoff = 0.5)

        # roc
        b1 <- twoClassSummary(data, lev, model)

        # auprc & f1 c1 <- prSummary(data, lev, model)

        # ppv & npv
        d1 <- predictiveValues(data, lev, model)

        # accuracy & kappa
        e1 <- defaultSummary(data, lev, model)

        out <- c(mcc, b1, d1, e1)
        names(out)[1] <- c("MCC")
        out
    }

    #PERFORMING RFE#

    rfectrl <- rfFuncs
    rfectrl$summary <- allSummary
    rfFuncs$fit <- function(x, y, param, first, last, ...) {
        randomForest::randomForest(x, y, ntree = tuneParams[[1]], nodesize = tuneParams[[2]],
                                   importance = TRUE, ...)
    }
    control <- rfeControl(functions = rfectrl, method = "cv", number = cvFolds,
                          verbose = ifelse(verbose == TRUE, TRUE, FALSE), allowParallel = FALSE)
    control$returnResamp <- "final"

    n <- dim(trainData)[2] - 1
    z <- numeric()
    x <- 0
    i <- 1
    while (x < n) {
        x <- 2^(i)
        i <- i + 1
        z <- c(z, x)
    }
    z[length(z)] <- n

    tadModel <- rfe(trainData[, -1], trainData[, 1], metric = cvMetric,
                    sizes = z, rfeControl = control)

    rfeModelResultsList <- list(tadModel$results, tadModel$variables[,
                                                                     -c(1, 2)])
    names(rfeModelResultsList) <- c("CVPerformances", "Importances")

    return(rfeModelResultsList)
}

#' Helper function used to create (log2) distance type feature space
#'
#' @param binned_data_center_gr A GRanges object of width 1
#' @param annot_data_center_gr A GRanges object of width 1
#'
#' @return A vector of log2 distances to the nearest overlap
#'
#' @import IRanges GenomicRanges
#'
distance_func <- function(binned_data_center_gr, annot_data_center_gr) {

    # distance from center of genomic bin to nearest genomic region of interest
    dist <- mcols(distanceToNearest(binned_data_center_gr, annot_data_center_gr))$distance

    return(dist)
}

#' Function to extract boundaries from domain data.
#'
#' @param domains.mat either a \code{matrix} or \code{data.frame} with at least
#' 3 columns. First column is chromosome number/character (1, 2, 3, X) or ID 
#' (chr1, chr2).  Non-autosomal/sex chromosomes will be filtered.
#' The second and third columns are the start and end coordinates 
#' of the domains, respectively. Note these are coordinates of the domain anchor
#' centers, not anchors. Only the first three columns are used. Required.
#' @param filter logical, indicating whether or not domains exceeding 2mb
#' in width or smaller than 2*(the specified resolution) should be filtered out
#' (default is FALSE, all boundaries will be used). Required.
#' @param CHR character vector, specifying which chromosome(s) to extract domain
#' boundaries on (ex: "chr22", case ignored). Unused seqnames are dropped. Required.
#' @param resolution numeric, the Hi-C data resolution that domains were called
#' at. Ignored if filter is FALSE, required otherwise.
#'
#' @return A \code{GRanges} object
#' @export
#'
#' @import IRanges GenomicRanges 
#' @importFrom gtools mixedorder
#' @examples
#' #Read in domain data from ARROWHEAD at 5 kb for GM12878
#' data("arrowhead_gm12878_5kb")
#' #Extract unique boundaries for CHRs 1-8 and 10-22
#' bounds.GR <- extractBoundaries(domains.mat=arrowhead_gm12878_5kb,
#'                                filter=FALSE,
#'                                CHR=paste0("CHR",c(1:8,10:22)),
#'                                resolution=5000)
extractBoundaries <- function(domains.mat, filter = FALSE, CHR, resolution) {
    
    resolution <- as.integer(resolution)
    #EXTRACTING UNIQUE BOUNDARIES#
    domains.mat <- domains.mat[, c(1,2,3)]
    # Filter out non-autosomal chromosomes that contain suffixes and underscores
    domains.mat <- domains.mat[!grepl("PATCH|CTG|ALT|GL|KI|UN|RND|_", domains.mat[, 1], ignore.case = TRUE, perl = TRUE), ]
    colnames(domains.mat) <- c("Chromosome", "Start", "End")
    domains.mat$Chromosome <- as.character(domains.mat$Chromosome)
    # Check if chromosomes have "chr" prefix, first three characters
    chr_prefix <- unique(substr(domains.mat$Chromosome, 1, 3))
    if (all(chr_prefix == "chr")) { 
        use_chr_prefix <- FALSE 
    } else { 
        use_chr_prefix <- TRUE 
    }
    
    if (filter == TRUE) {
        ## restricting domain data to TADs > 2*resolution and < 2,000,000
        domains.mat <- domains.mat[which((domains.mat$End - domains.mat$Start) >
                                             (2 * resolution) & (domains.mat$End - domains.mat$Start) < 2e+06), ]
    }
    
    ## concatenating boundary coordinates into one long vector
    coords <- domains.mat
    colnames(coords)[2:3] <- c("coordinate", "coordinate")
    coords <- rbind.data.frame(coords[, c(1, 2)], coords[, c(1, 3)])
    ## create a data frame for future GRanges    
    coords <- data.frame(chrom = paste0(ifelse(use_chr_prefix, "chr", ""), coords$Chromosome), start = coords$coordinate, end = coords$coordinate + 1)
    
    ## sorting by coordinate (smallest to largest), then chromosome (natural sort)
    coords <- coords[order(coords$start), ]
    coords <- coords[gtools::mixedorder(coords$chrom, decreasing = FALSE), ]
    ## remove duplicates for coordinates that are conjoined
    coords <- coords[!duplicated(coords), ]
    
    bounds <- GenomicRanges::makeGRangesFromDataFrame(coords)
    
    # chromsome specific boundary data
    bounds_chr_specific <- bounds[as.character(bounds@seqnames) %in% tolower(CHR)]

    return(bounds_chr_specific)
}

context("test-extractBoundaries")

test_that("Whether extractBoundaries gives us the same output", {

    data("arrowhead_gm12878_5kb")

    bounds.GR <- extractBoundaries(domains.mat=arrowhead_gm12878_5kb,
                                   filter=FALSE,
                                   CHR=paste0("CHR",c(1:8,10:22)),
                                   resolution=5000)

    expect_equal(length(bounds.GR), 15468)

})

#' A list of the chromosomal coordinates for 26 transcription factor binding
#' sites from the Gm12878 cell line
#'
#' A GRangesList containing 26 GRanges objects each with the following elements
#' \describe{
#' \item{seqnames}{The chromosome number}
#' \item{ranges}{IRanges object with start and end coordinates for each TFBS}
#' \item{strand}{empty column}
#' \item{coverage}{a metadata column with peak strength values at each site}
#' }
#'
#' @source Data obtained from ENCODE.
#' ENCODE integrative analysis (PMID: 22955616; PMCID: PMC3439153)
#' ENCODE portal (PMID: 29126249; PMCID: PMC5753278)
#' Available at
#' \url{https://www.encodeproject.org/}
#' @return A GrangeList
#'
"tfbsList"

#' Helper function used to create signal type feature space
#'
#' @param binned_data_gr A GRanges object
#' @param annot_data_gr A GRanges object
#'
#' @return A vector of intensities indicating the signal strength within each
#' overlap
#'
#' @importFrom S4Vectors queryHits
#' @import IRanges GenomicRanges
#'
signal_func <- function(binned_data_gr, annot_data_gr){

    count_signal <- numeric(length(binned_data_gr))

    #Finding the total number of overlaps between genomic bins and the specific genomic annotation
    c <- countOverlaps(binned_data_gr, annot_data_gr)

    #places where c=0 denotes no overlap
    #places where c>0 denotes some type of overlap, could be partial or within

    #for c=0 assign signal as 0
    count_signal[which(c==0)] <- 0

    #for c=1:
    count_signal[which(c==1)] <- mcols(annot_data_gr[S4Vectors::queryHits(findOverlaps(annot_data_gr,binned_data_gr[which(c==1)]))])$coverage

    #for c>1:
    #iterate through all bins with multiple overlaps with the annotation of interest
    #find how many and which annotations overlap within each iterate
    #calculate the width of each overlap
    #sum the total widths and divide by bin width
    #bins with some type of overlap
    mo <- which(c>1)
    count_signal[mo] <- unlist(lapply(mo, function(x){
        sum(mcols(pintersect(findOverlapPairs(annot_data_gr,binned_data_gr[x])))$coverage)/c[x]
    }))

    return(count_signal)
}

#' A wrapper function passed to \code{caret::train} to apply a random forest
#' classification algorithm built and tested on user-defined binned domain
#' data from \code{\link{createTADdata}}.
#'
#' @param trainData Data frame, the binned data matrix to built a random forest
#' classifiers (can be obtained using \code{\link{createTADdata}}). Required.
#' @param testData Data frame, the binned data matrix to test random forest
#' classifiers (can be obtained using \code{\link{createTADdata}}). The first
#' column must be a factor with positive class "Yes". Default is NULL in which
#' case no performances are evaluated.
#' @param tuneParams List, providing \code{mtry}, \code{ntree}, and
#' \code{nodesize} parameters to feed into \code{\link{randomForest}}. Default
#' is list(mtry = ceiling(sqrt(ncol(trainData) - 1)), ntree = 500,
#' nodesize = 1). If multiple values are provided, then a grid search is
#' performed to tune the model. Required.
#' @param cvFolds Numeric, number of k-fold cross-validation to perform in
#' order to tune the hyperparameters. Required.
#' @param cvMetric Character, performance metric to use to choose optimal
#' tuning parameters (one of either "Kappa", "Accuracy", "MCC", "ROC", "Sens",
#' "Spec", "Pos Pred Value", "Neg Pred Value"). Default is "Accuracy".
#' @param verbose Logical, controls whether or not details regarding modeling
#' should be printed out. Default is TRUE.
#' @param model Logical, whether to keep the model object. Default is TRUE.
#' @param importances Logical, whether to extract variable importances. Default
#' is TRUE.
#' @param impMeasure Character, indicates the variable importance measure to
#' use (one of either "MDA" (mean decrease in accuracy) or "MDG" (mean decrease
#' in gini)). Ignored if importances = FALSE.
#' @param performances Logical, indicates whether various performance metrics
#' should be extracted when validating the model on the test data. Ignored if
#' testData = NULL.
#'
#' @return A list containing: 1) a train object from \code{caret} with model
#' information, 2) a data.frame of variable importance for each feature
#' included in the model, and 3) a data.frame of various performance metrics
#' @export
#'
#' @importFrom ModelMetrics mcc
#' @importFrom PRROC pr.curve
#' @importFrom pROC roc
#' @importFrom pROC auc
#' @importFrom stats predict
#' @import randomForest caret e1071
#'
#' @examples
#' # Read in ARROWHEAD-called TADs at 5kb
#' data(arrowhead_gm12878_5kb)
#'
#' # Extract unique boundaries
#' bounds.GR <- extractBoundaries(domains.mat = arrowhead_gm12878_5kb,
#'                                filter = FALSE,
#'                                CHR = c("CHR21", "CHR22"),
#'                                resolution = 5000)
#'
#' # Read in GRangesList of 26 TFBS
#' data(tfbsList)
#'
#' # Create the binned data matrix for CHR1 (training) and CHR22 (testing)
#' # using 5 kb binning, distance-type predictors from 26 different TFBS from
#' # the GM12878 cell line, and random under-sampling
#' tadData <- createTADdata(bounds.GR = bounds.GR,
#'                          resolution = 5000,
#'                          genomicElements.GR = tfbsList,
#'                          featureType = "distance",
#'                          resampling = "rus",
#'                          trainCHR = "CHR21",
#'                          predictCHR = "CHR22")
#'
#' # Perform random forest using TADrandomForest by tuning mtry over 10 values
#' # using 3-fold CV
#' tadModel <- TADrandomForest(trainData = tadData[[1]],
#'                             testData = tadData[[2]],
#'                             tuneParams = list(mtry = c(2,5,8,10,13,16,18,21,24,26),
#'                                             ntree = 500,
#'                                             nodesize = 1),
#'                             cvFolds = 3,
#'                             cvMetric = "Accuracy",
#'                             verbose = TRUE,
#'                             model = TRUE,
#'                             importances = TRUE,
#'                             impMeasure = "MDA",
#'                             performances = TRUE)
TADrandomForest <- function(trainData,
                            testData = NULL,
                            tuneParams = list(mtry = ceiling(sqrt(ncol(trainData)-1)),
                                              ntree = 500,
                                              nodesize = 1),
                            cvFolds = 3,
                            cvMetric = "Accuracy",
                            verbose = FALSE,
                            model = TRUE,
                            importances = TRUE,
                            impMeasure = "MDA",
                            performances = FALSE){

    #################################
    #PREDICTING TAD BOUNDARY REGIONS#
    #################################

    ########################################################################
    #Establishing summary function to evaluate cross validation performance#
    ########################################################################

    predictiveValues <- function (data, lev = NULL, model = NULL,...){
        PPVobj <- posPredValue(data[, "pred"], data[, "obs"])
        NPVobj <- negPredValue(data[, "pred"], data[, "obs"])
        out <- c(PPVobj, NPVobj)
        #out <- c(NPVobj)
        names(out) <- c("Pos Pred Value", "Neg Pred Value")
        #names(out) <- c("Neg Pred Value")
        out}

    allSummary <- function(data, lev = NULL, model = NULL){
        lvls <- levels(data$obs)

        #mcc
        mcc <- mcc(ifelse(data$obs == lev[2], 0, 1), data[, lvls[1]], cutoff = .5)

        #roc
        b1 <- twoClassSummary(data, lev, model)

        #auprc & f1
        #c1 <- prSummary(data, lev, model)

        #ppv & npv
        d1 <- predictiveValues(data, lev, model)

        #accuracy & kappa
        e1 <- defaultSummary(data, lev, model)

        out <- c(mcc, b1, d1, e1)
        names(out)[1] <- c("MCC")
        out
    }

    ########################################
    #Establishing random forest using caret#
    ########################################

    customRF <- getModelInfo(model = "rf", regex = FALSE)
    customRF$rf$parameters <- data.frame(parameter = c("mtry", "ntree", "nodesize"),
                                         class = rep("numeric", 3),
                                         label = c("mtry", "ntree", "nodesize"))
    customRF$rf$grid <- function(x, y, len = NULL, search = "grid") {}
    customRF$rf$fit <- function(x, y, wts, param, lev, last, weights, classProbs, ...) {
        randomForest(x,
                     y,
                     mtry = param$mtry,
                     ntree=param$ntree,
                     nodesize = param$nodesize,
                     importance=TRUE,
                     ...)
    }

    ##########################
    #Establishing tuning grid#
    ##########################

    tunegrid <- expand.grid(mtry = tuneParams[[1]],
                            ntree = tuneParams[[2]],
                            nodesize = tuneParams[[3]])

    ###############################
    #Establishing control function#
    ###############################

    seeds <- vector(mode = "list", length = (cvFolds+1))
    for(i in seq_len(cvFolds)) {
        seeds[[i]] <- sample.int(n=100000, nrow(tunegrid))
    }
    #for the last model
    seeds[[cvFolds+1]] <- sample.int(100000, 1)

    control <- trainControl(seeds = seeds,
                            method = "cv",
                            number = cvFolds,
                            verboseIter = ifelse(verbose == TRUE, TRUE, FALSE),
                            ## Estimate class probabilities
                            classProbs = TRUE,
                            ## Evaluate performance using
                            ## the following function
                            summaryFunction = allSummary,
                            allowParallel = FALSE)



    tadModel <- train(y~.,
                      data = trainData,
                      method = customRF$rf,
                      metric = cvMetric,
                      tuneGrid = tunegrid,
                      trControl = control)

    #####################################
    #EXTRACTING IMPORTANCES/COEFFICIENTS#
    #####################################

    if(impMeasure == "MDA") {
        rfimpvars <- data.frame(Feature=rownames(randomForest::importance(tadModel$finalModel, scale = TRUE)),
                                Importance=as.vector(randomForest::importance(tadModel$finalModel, scale = TRUE)[,3]))
        rfimpvars <- rfimpvars[order(rfimpvars$Importance, decreasing = TRUE),]
    }else if(impMeasure == "MDG") {
        rfimpvars <- data.frame(Feature=rownames(randomForest::importance(tadModel$finalModel, scale = TRUE)),
                                Importance = as.vector(randomForest::importance(tadModel$finalModel, scale = TRUE)[,4]))
        rfimpvars <- rfimpvars[order(rfimpvars$Importance, decreasing = TRUE),]
    }else {
        rfimpvars <- NA
    }

    #################################
    #EVALUATING PERFORMANCES        #
    #################################

    if(!(is.null(testData)) & performances == TRUE){
        rfperf <- data.frame(Metric = c("TN",
                                        "FN",
                                        "FP",
                                        "TP",
                                        "Total",
                                        "Sensitivity",
                                        "Specificity",
                                        "Kappa",
                                        "Accuracy",
                                        "BalancedAccuracy",
                                        "Precision",
                                        "FPR",
                                        "FNR",
                                        "NPV",
                                        "MCC",
                                        "F1",
                                        "AUC",
                                        "Youden",
                                        "AUPRC"),
                             Performance = NA)

        pred.tadModel <- as.vector(predict(tadModel,
                                           newdata=testData[,-1],
                                           type = "prob")[,"Yes"])

        fg <- pred.tadModel[testData$y == "Yes"]
        bg <- pred.tadModel[testData$y == "No"]
        pr <- pr.curve(scores.class0 = fg, scores.class1 = bg, curve = TRUE)

        pred.tadModel2 <- predict(tadModel,
                                  newdata = testData[,-1],
                                  type = "raw")


        confMat <- caret::confusionMatrix(data=pred.tadModel2, testData[,1], positive="Yes")
        TN <- as.numeric(confMat$table[1,1])
        FN <- as.numeric(confMat$table[1,2])
        FP <- as.numeric(confMat$table[2,1])
        TP <- as.numeric(confMat$table[2,2])
        rfperf[1,2] <- TN
        rfperf[2,2] <- FN
        rfperf[3,2] <- FP
        rfperf[4,2] <- TP
        rfperf[5,2] <- sum(confMat$table)
        rfperf[6,2] <- as.vector(confMat$byClass["Sensitivity"])
        rfperf[7,2] <- as.vector(confMat$byClass["Specificity"])
        rfperf[8,2] <- as.vector(confMat$overall["Kappa"])
        rfperf[9,2] <- as.vector(confMat$overall["Accuracy"])
        rfperf[10,2] <- ((TP/(TP+FN)) + (TN/(FP+TN)))/2
        rfperf[11,2] <- TP/(TP+FP)
        rfperf[12,2] <- FP/(FP+TN)
        rfperf[13,2] <- FN/(FN+TN)
        rfperf[14,2] <- TN/(TN+FN)
        rfperf[15,2] <- (TP*TN - FP*FN)/( sqrt( (TP+FP)*(TP+FN)*(TN+FP)*(TN+FN) ) )
        rfperf[16,2] <- (2*(TP/(TP+FN))*(TP/(TP+FP)))/((TP/(TP+FN)) + ((TP/(TP+FP))))
        rfperf[17,2] <- pROC::auc(pROC::roc(testData$y, pred.tadModel, quiet = TRUE))
        rfperf[18,2] <- (TP/(TP + FN)) + (TN/(TN + FP)) - 1
        rfperf[19,2] <- pr$auc.integral
    }

    results_list <- list()

    if(model == TRUE){results_list[[1]] <- tadModel}else{results_list[[1]] <- NA}
    if(importances == TRUE){results_list[[2]] <- rfimpvars}else{results_list[[2]] <- NA}
    if(!(is.null(testData)) & performances == TRUE){results_list[[3]] <- rfperf}else{results_list[[3]] <- NA}

    return(results_list)
}

#' Precise TAD boundary prediction at base-level resolution using density-based
#' spatial clustering and partitioning techniques
#'
#' @param genomicElements.GR \code{GRangesList} object containing GRanges from
#' each ChIP-seq BED file that was used to train a predictive model (can be
#' obtained using the \code{\link{bedToGRangesList}}). Required.
#' @param featureType Controls how the feature space is constructed (one of
#' either "binary", "oc", "op", "signal, or "distance" (log2- transformed).
#' Default and recommended: "distance".
#' @param CHR Controls which chromosome to predict boundaries on at base-level
#' resolution, e.g., CHR22. Required.
#' @param chromCoords List containing the starting bp coordinate and ending bp
#' coordinate that defines the region of the linear genome to make predictions
#' on. If chromCoords is not specified, then predictions will be made on the
#' entire chromosome. Default is NULL.
#' @param tadModel Model object used to obtain predicted probabilities at
#' base-level resolution (examples include \code{gbm}, \code{glmnet},
#' \code{svm}, \code{glm}, etc). For a random forest model, can be obtained
#' using \code{preciseTAD::randomForest}). Required.
#' @param threshold Bases with predicted probabilities that are greater
#' than or equal to this value are labeled as potential TAD boundaries. Values
#' in the range of .95-1.0 are suggested. Default is 1. To explore how
#' selection of the `threshold` parameter affects the results, it is recommended
#' to rerun the function with a different threshold, e.g., 0.99, and compare the
#' results of Normalized Enrichment test (see `DBSCAN_params` and the 
#' `preciseTADparams` slot).
#' @param verbose Option to print progress. Default is TRUE.
#' @param parallel Option to parallelise the process for obtaining predicted
#' probabilities. Must be number to indicate the number of cores to use in
#' parallel. Default is NULL.
#' @param DBSCAN_params Parameters passed to \code{\link{dbscan}} in list form
#' containing 1) eps and 2) MinPts. If a vector of different values is passed to
#' either or both eps and MinPts, then each combination of these parameters is
#' evaluated to maximize normalized enrichment (NE) is the provided genomic 
#' annotations. Normalized Enrichment is calculated as the number of genomic 
#' annotations that overlap with flanked predicted boundary points (see the slope 
#' parameter) divided by the total number of predicted boundaries, averaged for 
#' all genomic annotations. Parameters yielding  maximum NE score are automatically 
#' selected for the final prediction. It is advisable to explore results 
#' of the NE test, available in the `preciseTADparams` slot of the returned 
#' object (NEmean - mean normalized enrichment, larger the better; k - number 
#' of PTBRs), to, potentially, find eps and MinPts parameters providing 
#' the number of PTBRs and the NE score better agreeing with the number
#' of boundaries used for training. Default: list(30000, 100). Required.
#' @param slope Controls how much to flank the predicted TAD boundary points for
#' calculating normalized enrichment. Default: 5000 bases. Required.
#' @param genome version of the human genome assembly. Used to filter out
#' bases overlapping centromeric regions. Accepted values - hg19 or 
#' hg38. Default: hg19
#' @param BaseProbs Option to include the vector of probabilities for each 
#' base-level coordinate. Recommended to be used only when chromCoords is 
#' specified. Default: FALSE
#' @param savetobed If true, preciseTAD regions (PTBRs) and preciseTAD points
#' (PTBPs) will be saved as BED-like files into the current folder 
#' (as.data.frame(GRanges)). File name convention: 
#' <PTBRs/PTBPs>_<threshold>_<MinPts>_<eps>.bed, e.g., PTBR_1_3_30000.bed. 
#' If multiple DBSCAN_params are specified, each result will
#' be saved in its own file. Default: FALSE
#'
#' @return A list containing 4 elements including:
#' 1) data frame with average (and standard deviation) normalized enrichment 
#' (NE) values for each combination of t and eps (only if multiple values are 
#' provided for at least paramenter; all subsequent summaries are applied to 
#' optimal combination of (t, eps)),
#' 2) the genomic coordinates spanning each preciseTAD predicted region (PTBR),
#' 3) the genomic coordinates of preciseTAD predicted boundaries points (PTBP),
#' 4) a named list including summary statistics of the following:
#' PTBRWidth - PTBR width, PTBRCoverage - the proportion of bases within a PTBR
#' with probabilities that equal to or exceed the threshold (t=1 by default),
#' DistanceBetweenPTBR - the genomic distance between the end of the previous
#' PTBR and the start of the subsequent PTBR, NumSubRegions - the number of
#' the subregions in each PTBR cluster, SubRegionWidth - the width of
#' the subregion forming each PTBR, DistBetweenSubRegions -
#' the genomic distance between the end of the previous PTBR-specific subregion
#' and the start of the subsequent PTBR-specific subregion, NormilizedEnrichment
#' - the normalized enrichment of the genomic annotations used in the model 
#' around flanked PTBPs, and BaseProbs - a numeric vector of probabilities for 
#' each corresponding base coordinate.
#' @export
#'
#' @importFrom pROC roc
#' @importFrom pROC coords
#' @importFrom stats predict
#' @importFrom stats hclust
#' @importFrom stats cutree
#' @importFrom stats dist
#' @importFrom stats setNames
#' @importFrom dbscan dbscan
#' @importFrom S4Vectors subjectHits
#' @importFrom utils write.table
#' @import pbapply parallel doSNOW foreach cluster IRanges GenomicRanges rCGH
#'
#' @examples
#' # Read in ARROWHEAD-called TADs at 5kb
#' data(arrowhead_gm12878_5kb)
#'
#' # Extract unique boundaries
#' bounds.GR <- extractBoundaries(domains.mat = arrowhead_gm12878_5kb,
#'                                filter = FALSE,
#'                                CHR = c("CHR21", "CHR22"),
#'                                resolution = 5000)
#'
#' # Read in GRangesList of 26 TFBS and filter to include only CTCF, RAD21,
#' #SMC3, and ZNF143
#' data(tfbsList)
#'
#' tfbsList_filt <- tfbsList[which(names(tfbsList) %in%
#'                                                  c("Gm12878-Ctcf-Broad",
#'                                                    "Gm12878-Rad21-Haib",
#'                                                    "Gm12878-Smc3-Sydh",
#'                                                    "Gm12878-Znf143-Sydh"))]
#'
#' # Create the binned data matrix for CHR1 (training) and CHR22 (testing)
#' # using 5 kb binning, distance-type predictors from 4 TFBS from
#' # the GM12878 cell line, and random under-sampling
#' set.seed(123)
#' tadData <- createTADdata(bounds.GR = bounds.GR,
#'                          resolution = 5000,
#'                          genomicElements.GR = tfbsList_filt,
#'                          featureType = "distance",
#'                          resampling = "rus",
#'                          trainCHR = "CHR21",
#'                          predictCHR = "CHR22")
#'
#' # Perform random forest using TADrandomForest by tuning mtry over 10 values
#' # using 3-fold CV
#' set.seed(123)
#' tadModel <- TADrandomForest(trainData = tadData[[1]],
#'                             testData = tadData[[2]],
#'                             tuneParams = list(mtry = 2,
#'                                             ntree = 500,
#'                                             nodesize = 1),
#'                             cvFolds = 3,
#'                             cvMetric = "Accuracy",
#'                             verbose = TRUE,
#'                             model = TRUE,
#'                             importances = TRUE,
#'                             impMeasure = "MDA",
#'                             performances = TRUE)
#'
#' # Apply preciseTAD on a specific 2mb section of CHR22:17000000-18000000
#' set.seed(123)
#' pt <- preciseTAD(genomicElements.GR = tfbsList_filt,
#'                  featureType = "distance",
#'                  CHR = "CHR22",
#'                  chromCoords = list(17000000, 18000000),
#'                  tadModel = tadModel[[1]],
#'                  threshold = 1.0,
#'                  verbose = TRUE,
#'                  parallel = NULL,
#'                  DBSCAN_params = list(c(1000, 10000, 30000), c(10, 100, 1000)),
#'                  slope = 5000,
#'                  genome = "hg19",
#'                  BaseProbs = FALSE,
#'                  savetobed = FALSE)
preciseTAD = function(genomicElements.GR, featureType = "distance", CHR,
                      chromCoords = NULL, tadModel, threshold = 1,
                      verbose = TRUE, parallel = NULL, DBSCAN_params = list(30000, 100),
                      slope = 5000, genome = "hg19", BaseProbs = FALSE, savetobed = FALSE) {

    #ESTABLISHING CHROMOSOME-SPECIFIC SEQINFO#

    #LOADING CHROMOSOME LENGTHS#
    if (genome %in% c("hg19", "hg38")) {
        ifelse(genome == "hg19", centromeres <- rCGH::hg19, centromeres <- rCGH::hg38)
        centromeres$chrom <- paste0("CHR", centromeres$chrom)
    } else {
        print("Wrong genome version. Use hg19 or hg38")
        return(NULL)
    }

    if(is.list(chromCoords)) {
        seqDataTest <- c(chromCoords[[1]]:chromCoords[[2]])
        if("TRUE" %in% table(seqDataTest %in% c(centromeres$centromerStart[centromeres$chrom == CHR]:centromeres$centromerEnd[centromeres$chrom == CHR]))) {
            centromereTestStart <- centromeres$centromerStart[centromeres$chrom==CHR]
            centromereTestEnd <- centromeres$centromerEnd[centromeres$chrom==CHR]
            seqDataTest <- seqDataTest[-which(seqDataTest %in% c(centromereTestStart:centromereTestEnd))]
        }
    } else {
        seqLengthTest <- centromeres$length[centromeres$chrom == CHR]
        seqDataTest <- seq_along(0:seqLengthTest)
        centromereTestStart <- centromeres$centromerStart[centromeres$chrom == CHR]
        centromereTestEnd <- centromeres$centromerEnd[centromeres$chrom == CHR]
        seqDataTest <- seqDataTest[-which(seqDataTest %in% c(centromereTestStart:centromereTestEnd))]
    }

    #CREATING BP RESOLUTION TEST DATA#
    test_data <- matrix(nrow = length(seqDataTest),
                        ncol = length(genomicElements.GR),
                        dimnames = list(NULL,names(genomicElements.GR)))
    # Split in 10M chunks
    if(verbose==TRUE){print(paste0("Establishing bp resolution test data using a ", featureType, " type feature space"))}
    for(j in seq_len(length(genomicElements.GR))){
        p <-list()
        for(i in seq_len(length(split(GRanges(seqnames=tolower(CHR),
                                        IRanges(start=seqDataTest,
                                                end=seqDataTest)),
                                ceiling(seq_along(GRanges(seqnames=tolower(CHR),
                                                          IRanges(start=seqDataTest,
                                                                  end=seqDataTest)))/10000000))))){
            if(featureType=="distance"){
                p[[i]] <- log(distance_func(split(GRanges(seqnames=tolower(CHR),
                                                          IRanges(start=seqDataTest,
                                                                  end=seqDataTest)),
                                                  ceiling(seq_along(GRanges(seqnames=tolower(CHR),
                                                                            IRanges(start=seqDataTest,
                                                                                    end=seqDataTest)))/10000000))[[i]],
                                            genomicElements.GR[[j]]) + 1,
                              base = 2)
            }else if(featureType=="binary"){
                p[[i]] <- binary_func(split(GRanges(seqnames=tolower(CHR),
                                                    IRanges(start=seqDataTest,
                                                            end=seqDataTest)),
                                            ceiling(seq_along(GRanges(seqnames=tolower(CHR),
                                                                      IRanges(start=seqDataTest,
                                                                              end=seqDataTest)))/10000000))[[i]],
                                      genomicElements.GR[[j]])
            }else if(featureType=="oc"){
                p[[i]] <- count_func(split(GRanges(seqnames=tolower(CHR),
                                                   IRanges(start=seqDataTest,
                                                           end=seqDataTest)),
                                           ceiling(seq_along(GRanges(seqnames=tolower(CHR),
                                                                     IRanges(start=seqDataTest,
                                                                             end=seqDataTest)))/10000000))[[i]],
                                     genomicElements.GR[[j]])
            }else{
                p[[i]] <- percent_func(split(GRanges(seqnames=tolower(CHR),
                                                     IRanges(start=seqDataTest,
                                                             end=seqDataTest)),
                                             ceiling(seq_along(GRanges(seqnames=tolower(CHR),
                                                                       IRanges(start=seqDataTest,
                                                                               end=seqDataTest)))/10000000))[[i]],
                                       genomicElements.GR[[j]])
            }
        }
        p <- unlist(p)
        test_data[,j] <- p
    }
    #rm("p", "g")

    #PREDICTING AT BP RESOLUTION #
    if (verbose == TRUE) { print("Establishing probability vector") }

    if(!is.null(parallel)){
        parallel_predictions<-function(fit, testing, c, n){
            cl<-makeCluster(c)
            registerDoSNOW(cl)
            split_testing<-sort(rank(seq_len(nrow(testing))) %% n)
            predictions<-foreach(i=unique(split_testing),
                                 .combine=c,
                                 .packages=c("caret")) %dopar% {
                                     as.numeric(predict(fit, newdata=testing[split_testing==i, ], type="prob")[, "Yes"])
                                 }
            stopCluster(cl)
            predictions
        }
        predictions <- parallel_predictions(fit=tadModel, testing=test_data, c=parallel, n=parallel)
    } else {
        if(!is.list(chromCoords)){
            array_split <- function(data, number_of_chunks){
                rowIdx <- seq_len(nrow(data))
                lapply(split(rowIdx, cut(rowIdx, pretty(rowIdx, number_of_chunks))), function(x) data[x, ])
            }
            split_ind <- as.integer(nrow(test_data)/10000000) + 1
            test_data <- array_split(test_data, split_ind)
            predictions <- list()
            for(i in seq_len(length(test_data))){
                predictions[[i]] <- predict(tadModel,newdata=test_data[[i]],type="prob")[,"Yes"]
            }
            predictions <- unlist(predictions)
        }else{
            predictions <- predict(tadModel,newdata=test_data,type="prob")[,"Yes"]
        }
    }

    #DETERMING OPTIMAL COMBINATION OF (MinPts, eps) #
    if (verbose == TRUE) {
        print("Determining optimal combination of epsilon neighborhood (eps) and minimum number of points (MinPts)")
    }
    
    ptMat <- expand.grid(DBSCAN_params[[2]], DBSCAN_params[[1]])
    colnames(ptMat) <- c("MinPts", "eps")
    ptMat$NEmean <- NA
    ptMat$k <- NA
    
    for(i in seq_len(nrow(ptMat))){
        if (verbose == TRUE) {
            print(paste0("Initializing DBSCAN for MinPts=",
                         ptMat$MinPts[i],
                         " and eps=",
                         ptMat$eps[i]))
        }
        
        res <- dbscan::dbscan(as.matrix(seqDataTest[which(predictions >= threshold )]), 
                              eps = ptMat$eps[i], 
                              minPts = ptMat$MinPts[i])
        if (0 %in% unique(res$cluster)) {
            k = length(unique(res$cluster)) - 1
        } else {
            k = length(unique(res$cluster))
        }
        
        if (verbose == TRUE) {
            print(paste0("    preciseTAD identified ", k, " PTBRs"))
            print(paste0("    Establishing PTBPs"))
        }
        
        # If at least 1 cluster is found
        if (k >= 1) {
            # Lists to store PTBPs and PTBRs
            medoids <- numeric()
            grlist <- GRangesList()
            # Process each cluster
            for(l in seq_len(k)){
                if(verbose == TRUE){print(paste0("        Cluster ", l, " out of ", k))}
                # Get PTBRs                
                bp <- seqDataTest[which(predictions >= threshold)][which(res$cluster==l)]
                grlist[[l]] <- GRanges(seqnames = tolower(CHR),
                                       IRanges(start=min(bp),
                                               end=max(bp)))
                # Find PTBPs
                cc <- pam(x = as.matrix(bp),
                          k = 1,
                          diss = FALSE,
                          metric = "euclidean",
                          medoids = NULL,
                          stand = FALSE,
                          cluster.only = FALSE,
                          do.swap = TRUE,
                          keep.diss = FALSE,
                          trace.lev = 0)
                medoids[l] <- cc$medoids[1]
                
            }
            # Make one GRanges with PTBRs
            grlist <- unlist(grlist)
            # Make one GRanges with PTBPs
            predBound_gr <- GRanges(seqnames=tolower(CHR),
                                    IRanges(start=medoids,
                                            end=medoids))
            # Save the data, if savetobed is set
            if (savetobed) {
                # Save PTBRs
                fileNameOut <- paste0("PTBRs_", threshold, "_", ptMat$MinPts[i], "_", ptMat$eps[i], ".bed")
                write.table(as.data.frame(grlist), fileNameOut, sep = "\t", row.names = FALSE, col.names = FALSE, quote = FALSE)
                # Save PTBPs
                fileNameOut <- paste0("PTBPs_", threshold, "_", ptMat$MinPts[i], "_", ptMat$eps[i], ".bed")
                write.table(as.data.frame(predBound_gr), fileNameOut, sep = "\t", row.names = FALSE, col.names = FALSE, quote = FALSE)
            }
            # Calculate normalized enrichment
            NormilizedEnrichment <- length(unique(subjectHits(GenomicRanges::findOverlaps(GenomicRanges::flank(predBound_gr, width = slope,  both = TRUE), unlist(genomicElements.GR))))) / length(predBound_gr)
            # Save the results
            ptMat$NEmean[i] <- NormilizedEnrichment
            ptMat$k[i] <- k
        } else { # If no clusters found
            ptMat$NEmean[i] <- 0
            ptMat$k[i] <- 0
        }
        
    }
    
    if (verbose == TRUE) { 
        print(paste0("Optimal combination of MinPts and eps is = (",
                     ptMat$MinPts[which.max(ptMat$NEmean)], ", ",
                     ptMat$eps[which.max(ptMat$NEmean)], ")"))
    }
    
    DBSCAN_params[[2]] = ptMat$MinPts[which.max(ptMat$NEmean)]
    DBSCAN_params[[1]] = ptMat$eps[which.max(ptMat$NEmean)]

    #PERFORMING preciseTAD ON OPTIMAL (MinPts, eps)
    if (verbose == TRUE) {
        print(paste0("preciseTAD identified a total of ", 
                     length(diff(seqDataTest[which(predictions >= threshold)])), 
                     " base pairs whose predictive probability was equal to or exceeded a threshold of ",
                     threshold))
        
        print(paste0("Initializing DBSCAN for MinPts = ", DBSCAN_params[[2]], 
                     " and eps = ", DBSCAN_params[[1]]))
    }
    
    res <- dbscan::dbscan(as.matrix(seqDataTest[which(predictions >= threshold)]), 
                          eps = DBSCAN_params[[1]], 
                          minPts = DBSCAN_params[[2]])
    if (0 %in% unique(res$cluster)) {
        k = length(unique(res$cluster)) - 1
    } else {
        k = length(unique(res$cluster))
    }
    
    if (verbose == TRUE) {
        print(paste0("preciseTAD identified ", k, " PTBRs"))
        print(paste0("Establishing PTBPs"))
    }
    
    # If at least 1 cluster is found
    if (k >= 1) {
        medoids <- numeric()
        grlist <- GRangesList()
        numsubreg <- numeric()
        distbtwsubreg <- numeric()
        coverage <- numeric()
        widthsubreg <- numeric()
        for(i in seq_len(k)){
            if(verbose == TRUE){print(paste0("Cluster ", i, " out of ", k))}
            
            bp <- seqDataTest[which(predictions>=threshold)][which(res$cluster==i)]
            
            grlist[[i]] <- GRanges(seqnames = tolower(CHR),
                                   IRanges(start=min(bp),
                                           end=max(bp)))
            
            if(0 %in% unique(res$cluster)){
                coverage[i] <- as.vector(table(res$cluster))[-1][i]/(max(bp)-min(bp)+1)
            }else{
                coverage[i] <- as.vector(table(res$cluster))[i]/(max(bp)-min(bp)+1)
            }
            
            if(identical(diff(bp[-which(diff(bp)==1)]), integer(0))){
                numsubreg[i] <- 1
                distbtwsubreg <- c(distbtwsubreg, 0)
            }else{
                numsubreg[i] <- length(diff(bp)[-which(diff(bp)==1)])+1
                distbtwsubreg <- c(distbtwsubreg, diff(bp)[-which(diff(bp)==1)])
            }
            
            retain <- c(1,cumsum(ifelse(diff(bp) != 1, 1, 0)) + 1)
            
            widthsubreg <- c(widthsubreg, as.vector(table(retain)))
            
            c <- pam(x = as.matrix(bp),
                     k = 1,
                     diss = FALSE,
                     metric = "euclidean",
                     medoids = NULL,
                     stand = FALSE,
                     cluster.only = FALSE,
                     do.swap = TRUE,
                     keep.diss = FALSE,
                     trace.lev = 0)
            medoids[i] <- c$medoids[1]
            
        }
        
        grlist <- unlist(grlist)
        
        predBound_gr <- GRanges(seqnames=tolower(CHR),
                                IRanges(start=medoids,
                                        end=medoids))
        
        if(0 %in% unique(res$cluster)){res$cluster <- res$cluster[-which(res$cluster==0)]}
        
        if(BaseProbs==TRUE){
            if(is.list(chromCoords)){
                predictions = stats::setNames(predictions, as.character(seq.int(chromCoords[[1]], chromCoords[[2]])))
            }else{
                predictions = stats::setNames(predictions, as.character(seqDataTest))
            }
        }else{
            predictions = NA
        }
        
        bp_results <- list(preciseTADparams=ptMat,
                           PTBR=grlist,
                           PTBP=predBound_gr,
                           Summaries=list(PTBRWidth = data.frame(min=min(width(grlist)),
                                                                 max=max(width(grlist)),
                                                                 median=median(width(grlist)),
                                                                 iqr=IQR(width(grlist)),
                                                                 mean=mean(width(grlist)),
                                                                 sd=sd(width(grlist))),
                                          PTBRCoverage = data.frame(min=min(coverage),
                                                                    max=max(coverage),
                                                                    median=median(coverage),
                                                                    iqr=IQR(coverage),
                                                                    mean=mean(coverage),
                                                                    sd=sd(coverage)),
                                          DistanceBetweenPTBR = data.frame(min=min(start(grlist)[-1]-end(grlist)[-length(end(grlist))]),
                                                                           max=max(start(grlist)[-1]-end(grlist)[-length(end(grlist))]),
                                                                           median=median(start(grlist)[-1]-end(grlist)[-length(end(grlist))]),
                                                                           iqr=IQR(start(grlist)[-1]-end(grlist)[-length(end(grlist))]),
                                                                           mean=mean(start(grlist)[-1]-end(grlist)[-length(end(grlist))]),
                                                                           sd=sd(start(grlist)[-1]-end(grlist)[-length(end(grlist))])),
                                          NumSubRegions = data.frame(min=min(numsubreg),
                                                                     max=max(numsubreg),
                                                                     median=median(numsubreg),
                                                                     iqr=IQR(numsubreg),
                                                                     mean=mean(numsubreg),
                                                                     sd=sd(numsubreg)),
                                          SubRegionWidth = data.frame(min=min(widthsubreg),
                                                                      max=max(widthsubreg),
                                                                      median=median(widthsubreg),
                                                                      iqr=IQR(widthsubreg),
                                                                      mean=mean(widthsubreg),
                                                                      sd=sd(widthsubreg)),
                                          DistBetweenSubRegions = data.frame(min=min(distbtwsubreg),
                                                                             max=max(distbtwsubreg),
                                                                             median=median(distbtwsubreg),
                                                                             iqr=IQR(distbtwsubreg),
                                                                             mean=mean(distbtwsubreg),
                                                                             sd=sd(distbtwsubreg)),
                                          NormilizedEnrichment = length(unique(subjectHits(GenomicRanges::findOverlaps(GenomicRanges::flank(predBound_gr, width = slope,  both = TRUE), unlist(genomicElements.GR))))) / length(predBound_gr),
                                          BaseProbs = predictions))
        
    } else { # If no clusters found
        print("No clusters found. Check your data and parameters.")
        bp_results <- NULL
    }
    
    # Save the data, if savetobed is set
    if (savetobed & !is.null(bp_results)) {
        # Save PTBRs
        fileNameOut <- paste0("PTBRs_", threshold, "_", DBSCAN_params[[2]], "_", DBSCAN_params[[1]], ".bed")
        write.table(as.data.frame(grlist), fileNameOut, sep = "\t", row.names = FALSE, col.names = FALSE, quote = FALSE)
        # Save PTBPs
        fileNameOut <- paste0("PTBPs_", threshold, "_", DBSCAN_params[[2]], "_", DBSCAN_params[[1]], ".bed")
        write.table(as.data.frame(predBound_gr), fileNameOut, sep = "\t", row.names = FALSE, col.names = FALSE, quote = FALSE)
    }
    
    return(bp_results)
}

#' Helper function for transforming a GRanges object into matrix form to be
#' saved as .txt or .BED file and imported into juicer
#'
#' @param grdat A GRanges object representing boundary coordinates
#'
#' @return A dataframe that can be saved as a BED file to import into juicer
#'
#' @export
#'
#' @import IRanges GenomicRanges
#'

juicer_func <- function(grdat) {
    # n <- length(unique(as.character(seqnames(grdat))))
    
    chrs <- unique(as.character(seqnames(grdat)))
    
    mat_list <- list()
    
    for (i in seq_len(length(chrs))) {
        grdat_chr <- grdat[which(as.character(seqnames(grdat)) == chrs[i])]
        
        if (length(grdat_chr) > 1) {
            mymat <- data.frame(matrix(nrow = (length(grdat_chr) - 1), ncol = 6))
            mymat[, 1] <- mymat[, 4] <- gsub("chr", "", chrs[i])
            for (j in seq_len(length(grdat_chr) - 1)) {
                mymat[j, 2] <- mymat[j, 5] <- start(grdat_chr)[j]
                mymat[j, 3] <- mymat[j, 6] <- start(grdat_chr)[j + 1]
            }
            
            mat_list[[i]] <- mymat
            
        }
        
    }
    
    mat_list <- do.call("rbind.data.frame", mat_list)
    names(mat_list) <- c("chr1", "x1", "x2", "chr2", "y1", "y2")
    return(mat_list)
    
}

---
title: "preciseTAD Vignette"
author:
- name: Spiro Stilianoudakis
  affiliation:
  - &1 Department of Biostatistics, Virginia Commonwealth University, Richmond, VA
- name: Mikhail Dozmorov
  affiliation:
  - *1
date: '`r format(Sys.Date(), "%B %e, %Y")`'
abstract: >
  Chromosome conformation capture technologies combined with high-throughput 
  sequencing (Hi-C) have revealed that chromatin undergoes layers of
  compaction through DNA looping and folding, forming dynamic 3D structures.
  Among these are Topologically Associating Domains (TADs) and chromatin loops,
  which are known to play critical roles in cell dynamics like gene regulation 
  and cell differentiation. Precise identification of TAD/loop (domain) boundaries 
  remains difficult, as it is strongly reliant on Hi-C data resolution. Obtaining 
  genome-wide chromatin interactions at high-resolution is costly resulting 
  in low resolution of Hi-C matrices and high uncertainty in the location of 
  domain boundaries. We developed a machine learning framework that leverages 
  the spatial relationship of high-resolution genome annotation data (e.g.,
  ChIP-seq-defined transcription factor binding sites) to maximally accurately
  predict low-resolution domain boundaries. Translated on a base level, the model
  predicts the probability of each base being a boundary. These probabilities,
  coupled with density-based clustering  and scalable partitioning 
  techniques, allow the precise (base-level) identification of domain boundary
  regions and points. We show that known molecular drivers of 
  3D chromatin structures including CTCF, RAD21, and SMC3 are more enriched 
  at our predicted boundaries, as compared with the boundaries 
  identified by the popular Arrowhead TAD caller. The model trained 
  in one cell type can leverage genomic annotations and predict boundaries 
  in another cell type.
package: preciseTAD
output:
    BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{preciseTAD}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
editor_options:
    chunk_output_type: console
bibliography: references.bib
---

```{r set-options, echo=FALSE, cache=FALSE}
options(width = 400)
knitr::opts_chunk$set(warnings = FALSE, message = FALSE)
```

# Introduction

`preciseTAD` is an R package designed to transform domain boundary calling into a supervised machine learning framework. `preciseTAD` offers full functionality in building the predictor-response data and selecting the best model for precise prediction of boundary regions. This functionality can be broken into 2 primary usages:

+ Model building, and
+ Precise domain boundary prediction

## Input data

The training/testing data used for modeling is represented as a matrix with rows being genomic regions, columns being genomic annotations, and cells containing measures of association between them. Users have the option to concatenate genomic regions from multiple chromosomes.

To create the row-wise dimension of the data, `preciseTAD` uses *shifted binning*, a strategy for making the dimensions of the data matrix used for modeling by segmenting the linear genome into nonoverlapping regions. This step is transparent for the user. To create shifted bins, chromosome-specific bins start at half of the resolution *r*, and continue in congruent intervals of length *r* until the end of the chromosome (*mod r* + *r/2*), using hg19 genomic coordinates. The shifted genomic bins, are then defined as boundary regions (*Y = 1*) if they contain a called boundary, and non-boundary regions (*Y = 0*) otherwise, thus establishing the binary response vector (**Y**) used for classification. Intuitively, shifted bins are centered on borders between the original bins, thus capturing potential boundaries. We found the shifted binning strategy improves model performance.

The column-wise dimension is formed by genomic annotations, such as transcription factor binding sites (TFBSs), histone modification marks, chromatin states. The *($log_{2}$) distances*, which enumerate the genomic distance from the center of each genomic bin to the center of the nearest ChIP-seq peak region of interest, form the feature space. Other feature type options include *binary overlaps* - an indicator for whether a ChIP-seq region overlaps with genomic bin, *count overlaps* - the number of overlaps in each bin, and *percent overlaps* - the percentage of overlap between any bin and the total width of all ChIP-seq regions overlapping it. The customized training/testing data formation offered by `preciseTAD` allows users to implement any binary classification machine learning algorithm. 

## preciseTAD functionality and output

`preciseTAD` implements a random forest (RF) model, allowing tuning hyperparameters and applying feature reduction. The primary inputs are the training and testing data, a list of hyperparameter values, the number of cross-validation folds to use (if a grid of hyperparameter values is provided), and the metric used for optimization. The output includes the model object (necessary for downstream prediction of boundaries), the variable importance values, and a list of performance metrics when validating the model on the testing data (see Table 1). This model is then used to predict base-level precise boundary locations.

To predict the base-level location of domain boundaries, the `preciseTAD` model is applied for each base annotated with the aforementioned genomic annotations. The base-level probabilities are clustered using density-based clustering and scalable data partitioning techniques, to narrow boundary regions and points. First, the probability vector, $p_{n_{i}}$, is extracted ($n_{i}$ representing the length of chromosome $i$). Next, *DBSCAN* (Density-based Spatial Clustering of Applications with Noise) [@ester1996density; @hahsler2019dbscan] is applied to the matrix of pairwise genomic distances between bases with $p_{n_{i}} \ge t$, where $t$ is a threshold determined by the user. The resulting clusters of highly predictive bases identified by DBSCAN are termed *preciseTAD boundary regions* (PTBR). To precisely identify a single base among each PTBR, *preciseTAD* implements partitioning around medoids (PAM) within each cluster. The corresponding cluster medoid is defined as a *preciseTAD boundary point* (PTBP), making it the most representative and biologically meaningful base within each clustered PTBR. The output includes a list of genomic coordinates of PTBPs and PTBSs.

`preciseTAD` allows us to use the pre-trained model to predict the precise location of domain boundaries in cell types without Hi-C data but with genome annotation data. Specifically, only cell-type-specific ChIP-seq data (BED format) for CTCF, RAD21, SMC3, and ZNF143 transcription factor binding sites is required. We provide models pre-trained using GM12878 and K562 genome annotation data, and Arrowhead- and Peakachu-predicted boundaries for chromosome-specific prediction of precise domain boundaries in other cell types.

# Getting Started

## Installation

```{r, eval = FALSE}
# if (!requireNamespace("BiocManager", quietly=TRUE))
#     install.packages("BiocManager")
BiocManager::install("preciseTAD")
# For the latest version install from GitHub
# BiocManager::install("dozmorovlab/preciseTAD")
```

```{r}
library(knitr)
library(e1071)
library(preciseTAD)
```

# Implementation

## Model building

### Construction of the data matrix

`preciseTAD` requires users to supply genomic coordinates of the "ground-truth" domain boundaries to establish the response vector (**Y**). As an example, we consider TAD boundaries derived from the popular *Arrowhead* TAD caller, a part of the Juicebox suite of tools developed by Aiden Lab [@durand2016juicer]. To get boundaries, *Arrowhead* was applied on the autosomal chromosomes using 5 kb GM12878 Hi-C data [@rao20143d] ([GSE63525](http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE63525)). An example of the command line script used to called TADs with *Arrowhead* is provided below, as well as the first three columns of the resulting TAD coordinates. A more detailed tutorial for implementing *Arrowhead* can be found [here](http://github.com/aidenlab/juicer/wiki/Arrowhead). 

```{r, eval=FALSE}
arrowhead -c 1 \ #chromosome to call TADs on
  -r 5000 \ #HiC data resolution
  ~/GSE63525_GM12878_insitu_primary.hic \ #location of the .HIC file
  ~/arrowhead_output #location to store the output
```


```{r}
data("arrowhead_gm12878_5kb")
head(arrowhead_gm12878_5kb)
```

Users will then need to transform this TAD coordinate data into a GRanges object of unique boundary coordinates using the `preciseTAD::extractBoundaries()` function. Note that the input for this function is a BED-like data frame where the second and third columns are genomic coordinates of domain anchor's midpoints. Here we only extract boundaries for CHR1 and CHR22 (`CHR = c("CHR1", "CHR22")` parameter). We specify `preprocess=FALSE` because we are only interested in all boundaries and not filtering TADs by length. Lastly, we specify `resolution=5000` to match the resolution used by *Arrowhead* (although this argument is ignored given that `preprocess=FALSE`). As shown below, there were a total of 1901 unique TAD boundaries reported by *Arrowhead* for chromosomes 1 and 22.

```{r}
bounds <- extractBoundaries(domains.mat = arrowhead_gm12878_5kb, filter = FALSE, CHR = c("CHR1", "CHR22"), resolution = 5000)
# View unique boundaries
bounds
```

To identify genomic features best predictive of TAD boundaries, `preciseTAD` requires functional genomic annotation data. They are used to establish the feature space ($\textbf{X}=\{X_{1}, X_{2}, \cdots, X_{p} \}$). Cell type-specific genomic annotation data can be downloaded from the [ENCODE](http://www.encodeproject.org/chip-seq-matrix/?type=Experiment&replicates.library.biosample.donor.organism.scientific_name=Homo%20sapiens&assay_title=TF%20ChIP-seq&status=released) data portal as BED files. Once you have downloaded your preferred list of functional genomic annotations, store them in a specific file location (i.e., "./path/to/BEDfiles"). These files can then be converted into a GRangesList object and used to create the feature space using the `preciseTAD::bedToGRangesList()` function. The `signal` argument refers to the column in the BED files containing peak signal strength values and is used to assign metadata to the corresponding GRanges (only necessary for downstream plotting). We have already provided a GRangesList object with 26 transcription factor binding sites (TFBS) specific to the GM12878 cell type. Once you load it in, you can see the list of transcription factors using the following commands.

```{r}
# path <- "./path/to/BEDfiles"
# tfbsList <- bedToGRangesList(filepath=path, bedList=NULL, bedNames=NULL, pattern = "*.bed", signal=4)

data("tfbsList")
names(tfbsList)
tfbsList
```

Using the "ground-truth" boundaries and the following TFBS, we can build the data matrix that will be used for predictive modeling. The `preciseTAD::createTADdata()` function can create the training and testing data. Here, we specify to train on chromosome 1 and test on chromosome 22. Additionally, we specify `resolution = 5000` to construct 5kb shifted genomic bins (to match the Hi-C data resolution), `featureType = "distance"` for a $log_2(distance + 1)$-type feature space, and `resampling = "rus"` to apply random under-sampling (RUS) on the training data to balance classes of boundary vs. non-boundary regions. We also specify a seed to ensure reproducibility when performing the resampling. The result is a list containing two data frames: (1) the resampled (if specified) training data, and (2) the testing data.

```{r}
set.seed(123)
tadData <- createTADdata(bounds.GR = bounds,
                         resolution = 5000,
                         genomicElements.GR = tfbsList,
                         featureType = "distance",
                         resampling = "rus",
                         trainCHR = "CHR1",
                         predictCHR = "CHR22")

# View subset of training data
tadData[[1]][1:5,1:4]
# Check it is balanced
table(tadData[[1]]$y)

# View subset of testing data
tadData[[2]][1:5,1:4]
```

### Feature selection using recursive feature elimination

We can now implement our machine learning algorithm of choice to predict boundary regions. Here, we opt for the random forest algorithm for binary classification. `preciseTAD` offers functionality for performing recursive feature elimination (RFE) as a form of feature reduction through the use of the `preciseTAD::TADrfe()` function, which is a wrapper for the `rfe` function in the `caret` package [@kuhn2012caret]. `preciseTAD::TADrfe()` implements a random forest model on the best subset of features from 2 to the maximum number of features in the data by powers of 2, using 5-fold cross-validation. We specify accuracy as the performance metric. An example is shown below.

```{r results='hide'}
set.seed(123)
rfe_res <- TADrfe(trainData = tadData[[1]],
                 tuneParams = list(ntree = 500, nodesize = 1),
                 cvFolds = 5,
                 cvMetric = "Accuracy",
                 verbose = TRUE)
```

```{r}
# View RFE performances
rfe_res[[1]]

# View the variable importance among top n features across each CV fold
head(rfe_res[[2]])
```

Recursive feature elimination results indicate that model accuracy begins to stabilize when only considering the top four transcription factors for building random forest predictive models (Figure 1A). After aggregating the variable importance values of the top four TFBS across each cross-fold, we see that the top four most important TFBS in each of the five folds are the SMC3, RAD21, CTCF, and ZNF143 (Figure 1B). These are known components of the loop-extrusion model that has been proposed as a mechanism for the 3D architecture of the human genome [@sanborn2015chromatin; @fudenberg2016formation; @hansen2018recent]. 

![**Figure 1**. (A) Recursive feature elimination (RFE) indicates that performance stabilizes when only considering the top 4 most predictive transcription factor binding sites (TFBS). (B) Aggregate mean variable importance (using mean decrease in accuracy) for the top 4 TFBS across each of the 5 cross-folds.](figures/fig1_vignette.png)


### Implementing a random forest for boundary prediction

Now that we have suitably reduced our feature space, we can implement a random forest algorithm built simply on the TFBS mentioned above (SMC3, RAD21, CTCF, and ZNF143). We can take advantage of the `preciseTAD::TADrandomForest()` function, which is a wrapper of the `randomForest` package [@breiman2001random; @liaw2002classification]. We specify the training and testing data, the hyperparameter values, the number of cross-validation folds, the performance metric to consider (here, accuracy), the seed to initialize for reproducibility, an indicator for retaining the model object, an indicator for retaining variable importances, the variable importance measure to consider (here, mean decrease in accuracy (MDA)), and an indicator for retaining model performances based on the test data. The function returns a list containing: 1) a trained model from caret with model information (`tadModel[[1]]`), 2) a `data.frame` of variable importance for each feature included in the model (`tadModel[[2]]`), and 3) a `data.frame` of various model performance metrics.

```{r}
# Restrict the data matrix to include only SMC3, RAD21, CTCF, and ZNF143
tfbsList_filt <- tfbsList[names(tfbsList) %in% c("Gm12878-Ctcf-Broad", 
                                            "Gm12878-Rad21-Haib",
                                            "Gm12878-Smc3-Sydh",
                                            "Gm12878-Znf143-Sydh")]

set.seed(123)
tadData <- createTADdata(bounds.GR   = bounds,
                         resolution  = 5000,
                         genomicElements.GR = tfbsList_filt,
                         featureType = "distance",
                         resampling  = "rus",
                         trainCHR    = "CHR1",
                         predictCHR  = "CHR22")

# Run RF
set.seed(123)
tadModel <- TADrandomForest(trainData  = tadData[[1]],
                            testData   = tadData[[2]],
                            tuneParams = list(mtry     = 2,
                                              ntree    = 500,
                                              nodesize = 1),
                            cvFolds      = 3,
                            cvMetric     = "Accuracy",
                            verbose      = FALSE,
                            model        = TRUE,
                            importances  = TRUE,
                            impMeasure   = "MDA",
                            performances = TRUE)
```

```{r}
# View model performances
performances <- tadModel[[3]]
performances$Performance <- round(performances$Performance, digits = 2)
rownames(performances) <- performances$Metric
kable(t(performances), caption = "List of model performances when validating an RF built on CHR1 on CHR22 test data.")
```

As you may know, there exist other machine learning binary classifiers that can be used in this setting. For example, suppose we opt to implement a support vector machine (SVM). This is easy enough to accomplish given that `preciseTAD::createTADdata()` conveniently sets up the training and testing data sets. We use the `e1071` package to run the SVM with a radial kernel, cost = 1, and gamma = 0.5 using the example command below. We see that the SVM model's accuracy is only 0.67, whereas the accuracy from our random forest was 0.69 (Table 1).

```{r}
svmModel <- svm(y ~ ., data = tadData[[1]], kernel = "radial", cost = 1, gamma = 0.5)

svmPreds <- predict(svmModel, tadData[[2]][, -1], positive = "Yes")

# View confusion matrix
table(svmPreds, tadData[[2]][, 1])
```

## Precise boundary prediction

Recall that our model classifies boundary **regions**, in that each prediction refers to a genomic bin of width 5000 bases. To predict boundary coordinates at the base resolution more precisely, we can leverage our model through the use of the `preciseTAD::preciseTAD()` function.  Conceptually, instead of genomic bins, we annotate each base with the selected genomic annotations and featureType. We then apply our model on this annotation matrix to predict the probability of each base is a boundary given the associated genomic annotations. To minimize computational costs, the base-level prediction should be performed in selected regions.

### Running preciseTAD

Suppose we want to precisely predict the domain boundary coordinates for the 2Mb section of CHR22:25,500,000-27,500,000. To do so, we specify `chromCoords = list(25500000, 27500000)`. Additionally, we set a range of probability threshold values including 0.975, 0.99, and 1.0 used for constructing PTBRs. For DBSCAN, we assign a range of $\epsilon$-neighborhood values including 5000, 10000, 15000, 20000, and 30000 and maintain 3 as the *MinPts* value. We specify `verbose=TRUE` so that the function will print out some minor results for each combination of $(t, \epsilon)$ as well as the overall best combination

```{r message=FALSE}
# Run preciseTAD
set.seed(123)
pt <- preciseTAD(genomicElements.GR = tfbsList_filt,
                featureType         = "distance",
                CHR                 = "CHR22",
                chromCoords         = list(17000000, 18000000),
                tadModel            = tadModel[[1]],
                threshold           = 1,
                verbose             = TRUE,
                parallel            = NULL,
                DBSCAN_params       = list(eps = c(30000), # c(10000, 30000, 50000)
                                           MinPts = c(100)), # c(3, 10, 100)
                slope               = 5000,
                genome              = "hg19",
                BaseProbs           = TRUE)

# What is getting returned? PTBRs - precide TAD boundary regions, and PTBPs - boundary points
names(pt)
# View the results
# pt
```

When specifying `verbose=TRUE` the function provides brief output for all $t \times \epsilon$ combinations including how many PTBRs/PTBPs result from each combination. NOTE: it is advised to provide `verbose=FALSE` when implementing *preciseTAD* using multiple $t$ and $\epsilon$ on the entire chromosome. Additionally, we see from the verbose statements that the optimal combination of $(t, \epsilon) = (1, 30000)$.

The full output of the `preciseTAD::preciseTAD()` function is a list with 4 elements: 1) data frame with average (and standard deviation) normalized enrichment (NE) values for each combination of t and eps (only if multiple values are provided for at least paramenter; all subsequent summaries are applied to optimal combination of (t, eps)), 2) the genomic coordinates spanning each preciseTAD predicted region (PTBR), 3) the genomic coordinates of preciseTAD predicted boundaries points (PTBP). 4) a named list including summary statistics of the following: PTBRWidth - PTBR width, PTBRCoverage - the ratio of base level coordinates  with probabilities that exceed the threshold to PTBRWidth,  DistanceBetweenPTBR - the genomic distance between the end of the previous PTBR and the start of the subsequent PTBR, NumSubRegions - the number of elements in each PTBR cluster, SubRegionWidth - the genomic coordinates spanning the subregion associated with each PTBR, DistBetweenSubRegions - the genomic distance between the end of the previous PTBR-specific region and the start of the subsequent PTBR-specific region, NormilizedEnrichment - the normalized enrichment of the genomic annotations used in the model around flanked PTBPs, and BaseProbs - a numeric vector of probabilities for each corresponding base coordinate. Normalized enrichment is calculated as the total number of peak regions that overlap with flanked predicted boundaries divided by the number of predicted boundaries. A schematic of how each of the summaries are calculated is presented in Figure 2.

![**Figure 2**. A schematic illustrating how each of the diagnostic summaries are calculated in the *preciseTAD()* output.](figures/fig2_vignette.png)

The vector of base-specific probabilities of being a boundary (`BaseProbs`) may be large, depending on the `chromCoords` settings. In our example, it has 2 million entries. Be careful when setting `BaseProbs = TRUE` to avoid memory issues. To see how the probabilities for the first five hundred bases look like, we do:

```{r}
plot(pt$Summaries$BaseProbs[1:100000])
```

We can see that the probability of being a boundary seems to peak around 200 and 400 bases. It is well below 1, but may be worth further investigation. 

### Using preciseTAD with Juicebox

Juicebox is an interface provided by Aiden Lab that allows for superimposing boundary coordinates onto Hi-C contact maps. To visualize domains flanked by the predicted boundaries, you must first select a Hi-C map. As an example, you can import the contact matrix for GM12878 derived by Rao et al. 2014 by choosing `File -> Open... -> Rao and Huntley et al. -> GM12878 -> in situ Mbol -> primary`. To format `preciseTAD` results to use in Juicebox, users can take advantage of `preciseTAD::juicer_func()`, which is a function available in the `preciseTAD` R package that transforms a GRanges object into a data frame as shown below. 

```{r, eval=FALSE}
# Transform
pt_juice <- juicer_func(pt$PTBP)
```

You will then need to save the PTBPs as a BED file using `write.table` as shown below. Once saved, import them into Juicebox using `Show Annotation Panel -> 2D Annotations -> Add Local -> pt_juice.bed`.

```{r, eval=FALSE}
filepath = "~/path/to/store/ptbps"
write.table(pt_juice, 
            file.path(filepath, "pt_juice.bed"),
            quote = FALSE,
            col.names = FALSE,
            row.names = FALSE,
            sep = "\t")
```

### Cross-cell-type prediction

`preciseTAD` allows us to use the pre-trained model to predict the precise location of domain boundaries in cell types without Hi-C data but with genome annotation data. Specifically, only the cell type-specific ChIP-seq data (BED format) for CTCF, RAD21, SMC3, and ZNF143 transcription factor binding sites is required. These data need to be assembled in a GRanges object using the aforementioned `bedToGRangesList()` function (i.e., creating another cell-type-specific `tfbsList_filt` object). 

The pre-trained model `tadModel` can be obtained by using `bedToGRangesList()`, `extractBoundaries()`, `createTADdata()`, and `TADrandomForest()` functions, as described. Alternatively, chromosome-specific pre-trained models can be downloaded from the [OneDrive storage](https://1drv.ms/u/s!AhmbAyu-bORbgutlR0_b-DJP9jTNKw?e=zZhASJ)<!--[Google Drive folder](http://1drv.ms/u/s!AhmbAyu-bORbgutlR0_b-DJP9jTNKw?e=zZhASJ)-->. We recommend models pre-trained using GM12878 genome annotation data and Peakachu peaks. Note that each model is annotated with "CHRi_holdout", representing the chromosome held out of training, and thus to be used to predict boundaries. It should be noted that the pretrained _preciseTAD_ models were trained on cancer cell lines (GM12878 and K562). Although we expect that the fundamental rules of domain boundary formation (CTCF etc. binding) will be preserved in cancer cells, use caution when applying the pretrained models to predict boindaries in normal cell lines.

As an example, we consider the Hela-S3 cell line. We will download and use the [CHR22_GM12878_5kb_Peakachu](https://1drv.ms/u/s!AhmbAyu-bORbguwDMgw2fA6Z84sYsQ?e=UrMUky) model to predict boundaries for chr22 in the Hela-S3 cell line.

```{r, eval=FALSE}
# Read in RF model built on chr1-chr21
tadModel <- readRDS("~/Downloads/CHR22_GM12878_5kb_Peakachu.rds")
```

The Hela-S3-specific BED-formatted TFBS data can be downloaded at [ENCODE](http://www.encodeproject.org/chip-seq-matrix/?type=Experiment&replicates.library.biosample.donor.organism.scientific_name=Homo%20sapiens&assay_title=TF%20ChIP-seq&status=released). The selected TFBS data can be downloaded from the [supplementary repository](http://github.com/stilianoudakis/preciseTAD_supplementary/tree/master/data/bed/hela). They can be converted into a GRangesList.

```{r, eval=FALSE}
# Establishing Hela-specific genomic annotations
# Reading in CTCF, RAD21, SMC3, and ZNF143 from repository and storing as list
ctcf <- as.data.frame(read.delim("http://raw.githubusercontent.com/stilianoudakis/preciseTAD_supplementary/master/data/bed/hela/ctcf.bed", sep = "\t", header = FALSE))
rad21 <- as.data.frame(read.delim("http://raw.githubusercontent.com/stilianoudakis/preciseTAD_supplementary/master/data/bed/hela/rad21.bed", sep = "\t", header = FALSE))
smc3 <- as.data.frame(read.delim("http://raw.githubusercontent.com/stilianoudakis/preciseTAD_supplementary/master/data/bed/hela/smc3.bed", sep = "\t", header = FALSE))
znf143 <- as.data.frame(read.delim("http://raw.githubusercontent.com/stilianoudakis/preciseTAD_supplementary/master/data/bed/hela/znf143.bed", sep = "\t", header = FALSE))
helaList <- list(ctcf, rad21, smc3, znf143)

hela.GR <- bedToGRangesList(bedList=helaList, bedNames=c("Ctcf", "Rad21", "Smc3", "Znf143"), signal=5)
```

Now we are ready to predict boundaries on chr22 for Hela-S3.

```{r, eval=FALSE}
# Run preciseTAD
set.seed(123)
pt <- preciseTAD(genomicElements.GR = hela.GR,
                featureType         = "distance",
                CHR                 = "CHR22",
                chromCoords         = list(25500000, 27500000),
                tadModel            = tadModel[[1]],
                threshold           = 1.0,
                verbose             = FALSE,
                parallel            = NULL,
                DBSCAN_params       = list(30000, 100),
                slope               = 5000,
                BaseProbs           = FALSE,
                savetobed           = FALSE)

```


# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/juicer_func.R
\name{juicer_func}
\alias{juicer_func}
\title{Helper function for transforming a GRanges object into matrix form to be
saved as .txt or .BED file and imported into juicer}
\usage{
juicer_func(grdat)
}
\arguments{
\item{grdat}{A GRanges object representing boundary coordinates}
}
\value{
A dataframe that can be saved as a BED file to import into juicer
}
\description{
Helper function for transforming a GRanges object into matrix form to be
saved as .txt or .BED file and imported into juicer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preciseTAD.R
\name{preciseTAD}
\alias{preciseTAD}
\title{Precise TAD boundary prediction at base-level resolution using density-based
spatial clustering and partitioning techniques}
\usage{
preciseTAD(
  genomicElements.GR,
  featureType = "distance",
  CHR,
  chromCoords = NULL,
  tadModel,
  threshold = 1,
  verbose = TRUE,
  parallel = NULL,
  DBSCAN_params = list(30000, 100),
  slope = 5000,
  genome = "hg19",
  BaseProbs = FALSE,
  savetobed = FALSE
)
}
\arguments{
\item{genomicElements.GR}{\code{GRangesList} object containing GRanges from
each ChIP-seq BED file that was used to train a predictive model (can be
obtained using the \code{\link{bedToGRangesList}}). Required.}

\item{featureType}{Controls how the feature space is constructed (one of
either "binary", "oc", "op", "signal, or "distance" (log2- transformed).
Default and recommended: "distance".}

\item{CHR}{Controls which chromosome to predict boundaries on at base-level
resolution, e.g., CHR22. Required.}

\item{chromCoords}{List containing the starting bp coordinate and ending bp
coordinate that defines the region of the linear genome to make predictions
on. If chromCoords is not specified, then predictions will be made on the
entire chromosome. Default is NULL.}

\item{tadModel}{Model object used to obtain predicted probabilities at
base-level resolution (examples include \code{gbm}, \code{glmnet},
\code{svm}, \code{glm}, etc). For a random forest model, can be obtained
using \code{preciseTAD::randomForest}). Required.}

\item{threshold}{Bases with predicted probabilities that are greater
than or equal to this value are labeled as potential TAD boundaries. Values
in the range of .95-1.0 are suggested. Default is 1. To explore how
selection of the `threshold` parameter affects the results, it is recommended
to rerun the function with a different threshold, e.g., 0.99, and compare the
results of Normalized Enrichment test (see `DBSCAN_params` and the 
`preciseTADparams` slot).}

\item{verbose}{Option to print progress. Default is TRUE.}

\item{parallel}{Option to parallelise the process for obtaining predicted
probabilities. Must be number to indicate the number of cores to use in
parallel. Default is NULL.}

\item{DBSCAN_params}{Parameters passed to \code{\link{dbscan}} in list form
containing 1) eps and 2) MinPts. If a vector of different values is passed to
either or both eps and MinPts, then each combination of these parameters is
evaluated to maximize normalized enrichment (NE) is the provided genomic 
annotations. Normalized Enrichment is calculated as the number of genomic 
annotations that overlap with flanked predicted boundary points (see the slope 
parameter) divided by the total number of predicted boundaries, averaged for 
all genomic annotations. Parameters yielding  maximum NE score are automatically 
selected for the final prediction. It is advisable to explore results 
of the NE test, available in the `preciseTADparams` slot of the returned 
object (NEmean - mean normalized enrichment, larger the better; k - number 
of PTBRs), to, potentially, find eps and MinPts parameters providing 
the number of PTBRs and the NE score better agreeing with the number
of boundaries used for training. Default: list(30000, 100). Required.}

\item{slope}{Controls how much to flank the predicted TAD boundary points for
calculating normalized enrichment. Default: 5000 bases. Required.}

\item{genome}{version of the human genome assembly. Used to filter out
bases overlapping centromeric regions. Accepted values - hg19 or 
hg38. Default: hg19}

\item{BaseProbs}{Option to include the vector of probabilities for each 
base-level coordinate. Recommended to be used only when chromCoords is 
specified. Default: FALSE}

\item{savetobed}{If true, preciseTAD regions (PTBRs) and preciseTAD points
(PTBPs) will be saved as BED-like files into the current folder 
(as.data.frame(GRanges)). File name convention: 
<PTBRs/PTBPs>_<threshold>_<MinPts>_<eps>.bed, e.g., PTBR_1_3_30000.bed. 
If multiple DBSCAN_params are specified, each result will
be saved in its own file. Default: FALSE}
}
\value{
A list containing 4 elements including:
1) data frame with average (and standard deviation) normalized enrichment 
(NE) values for each combination of t and eps (only if multiple values are 
provided for at least paramenter; all subsequent summaries are applied to 
optimal combination of (t, eps)),
2) the genomic coordinates spanning each preciseTAD predicted region (PTBR),
3) the genomic coordinates of preciseTAD predicted boundaries points (PTBP),
4) a named list including summary statistics of the following:
PTBRWidth - PTBR width, PTBRCoverage - the proportion of bases within a PTBR
with probabilities that equal to or exceed the threshold (t=1 by default),
DistanceBetweenPTBR - the genomic distance between the end of the previous
PTBR and the start of the subsequent PTBR, NumSubRegions - the number of
the subregions in each PTBR cluster, SubRegionWidth - the width of
the subregion forming each PTBR, DistBetweenSubRegions -
the genomic distance between the end of the previous PTBR-specific subregion
and the start of the subsequent PTBR-specific subregion, NormilizedEnrichment
- the normalized enrichment of the genomic annotations used in the model 
around flanked PTBPs, and BaseProbs - a numeric vector of probabilities for 
each corresponding base coordinate.
}
\description{
Precise TAD boundary prediction at base-level resolution using density-based
spatial clustering and partitioning techniques
}
\examples{
# Read in ARROWHEAD-called TADs at 5kb
data(arrowhead_gm12878_5kb)

# Extract unique boundaries
bounds.GR <- extractBoundaries(domains.mat = arrowhead_gm12878_5kb,
                               filter = FALSE,
                               CHR = c("CHR21", "CHR22"),
                               resolution = 5000)

# Read in GRangesList of 26 TFBS and filter to include only CTCF, RAD21,
#SMC3, and ZNF143
data(tfbsList)

tfbsList_filt <- tfbsList[which(names(tfbsList) \%in\%
                                                 c("Gm12878-Ctcf-Broad",
                                                   "Gm12878-Rad21-Haib",
                                                   "Gm12878-Smc3-Sydh",
                                                   "Gm12878-Znf143-Sydh"))]

# Create the binned data matrix for CHR1 (training) and CHR22 (testing)
# using 5 kb binning, distance-type predictors from 4 TFBS from
# the GM12878 cell line, and random under-sampling
set.seed(123)
tadData <- createTADdata(bounds.GR = bounds.GR,
                         resolution = 5000,
                         genomicElements.GR = tfbsList_filt,
                         featureType = "distance",
                         resampling = "rus",
                         trainCHR = "CHR21",
                         predictCHR = "CHR22")

# Perform random forest using TADrandomForest by tuning mtry over 10 values
# using 3-fold CV
set.seed(123)
tadModel <- TADrandomForest(trainData = tadData[[1]],
                            testData = tadData[[2]],
                            tuneParams = list(mtry = 2,
                                            ntree = 500,
                                            nodesize = 1),
                            cvFolds = 3,
                            cvMetric = "Accuracy",
                            verbose = TRUE,
                            model = TRUE,
                            importances = TRUE,
                            impMeasure = "MDA",
                            performances = TRUE)

# Apply preciseTAD on a specific 2mb section of CHR22:17000000-18000000
set.seed(123)
pt <- preciseTAD(genomicElements.GR = tfbsList_filt,
                 featureType = "distance",
                 CHR = "CHR22",
                 chromCoords = list(17000000, 18000000),
                 tadModel = tadModel[[1]],
                 threshold = 1.0,
                 verbose = TRUE,
                 parallel = NULL,
                 DBSCAN_params = list(c(1000, 10000, 30000), c(10, 100, 1000)),
                 slope = 5000,
                 genome = "hg19",
                 BaseProbs = FALSE,
                 savetobed = FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/arrowhead_gm12878_5kb.R
\docType{data}
\name{arrowhead_gm12878_5kb}
\alias{arrowhead_gm12878_5kb}
\title{Domain data from ARROWHEAD TAD-caller for GM12878 at 5 kb}
\format{
An object of class \code{data.frame} with 8409 rows and 3 columns.
}
\source{
Data from Rao SS, Huntley MH, Durand NC, Stamenova EK et al.
A 3D map of the human genome at kilobase resolution reveals principles
of chromatin looping. Cell 2014 Dec 18;159(7):1665-80. PMID: 25497547.
Available at
\url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE63525}
}
\usage{
arrowhead_gm12878_5kb
}
\value{
A data.frame
}
\description{
A data frame with 3 columns and 8409 rows
\describe{
\item{V1}{The chromosome number}
\item{V2}{The start coordinate of the TAD}
\item{V3}{The end coordinate of the TAD}
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bedToGRangesList.R
\name{bedToGRangesList}
\alias{bedToGRangesList}
\title{Function to create a GRangesList object from functional genomic annotation
data in the form of BED files}
\usage{
bedToGRangesList(
  filepath,
  bedList = NULL,
  bedNames = NULL,
  pattern = "*.bed",
  signal = NULL
)
}
\arguments{
\item{filepath}{Character describing the path to the folder containing the
BED files of functional genomic annotations. This is ignored if bedList is
specified.}

\item{bedList}{A list object containing the bed data as data frames to be
converted into a GRangesList. The data frames must include at least
chromosome, start, and end coordinates as the first 3 columns. Default is
NULL.}

\item{bedNames}{A character vector to provide names to the GRangesList,
should be in the order of bedList. Default is NULL.}

\item{pattern}{Character describing the pattern of the files for the
functional genomic annotations. Default is "*.bed".}

\item{signal}{The column number in the BED files that denotes coverage 
strength. Must be the same for all files. Default is NULL indicating to no 
coverage value is to be used.}
}
\value{
A \code{GRangesList} object where each entry is a \code{GRanges}
object specific to each BED file in the path provided
}
\description{
Function to create a GRangesList object from functional genomic annotation
data in the form of BED files
}
\examples{
#set path
path <- system.file("extdata", package = "preciseTAD")
#contains 2 BED files representing YY1 and NFYA
#transcription factor binding sites for GM12878
tfbsList <- bedToGRangesList(filepath = path, bedList=NULL, bedNames=NULL,
pattern = "*.bed", signal=NULL)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extractBoundaries.R
\name{extractBoundaries}
\alias{extractBoundaries}
\title{Function to extract boundaries from domain data.}
\usage{
extractBoundaries(domains.mat, filter = FALSE, CHR, resolution)
}
\arguments{
\item{domains.mat}{either a \code{matrix} or \code{data.frame} with at least
3 columns. First column is chromosome number/character (1, 2, 3, X) or ID 
(chr1, chr2).  Non-autosomal/sex chromosomes will be filtered.
The second and third columns are the start and end coordinates 
of the domains, respectively. Note these are coordinates of the domain anchor
centers, not anchors. Only the first three columns are used. Required.}

\item{filter}{logical, indicating whether or not domains exceeding 2mb
in width or smaller than 2*(the specified resolution) should be filtered out
(default is FALSE, all boundaries will be used). Required.}

\item{CHR}{character vector, specifying which chromosome(s) to extract domain
boundaries on (ex: "chr22", case ignored). Unused seqnames are dropped. Required.}

\item{resolution}{numeric, the Hi-C data resolution that domains were called
at. Ignored if filter is FALSE, required otherwise.}
}
\value{
A \code{GRanges} object
}
\description{
Function to extract boundaries from domain data.
}
\examples{
#Read in domain data from ARROWHEAD at 5 kb for GM12878
data("arrowhead_gm12878_5kb")
#Extract unique boundaries for CHRs 1-8 and 10-22
bounds.GR <- extractBoundaries(domains.mat=arrowhead_gm12878_5kb,
                               filter=FALSE,
                               CHR=paste0("CHR",c(1:8,10:22)),
                               resolution=5000)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/distance_func.R
\name{distance_func}
\alias{distance_func}
\title{Helper function used to create (log2) distance type feature space}
\usage{
distance_func(binned_data_center_gr, annot_data_center_gr)
}
\arguments{
\item{binned_data_center_gr}{A GRanges object of width 1}

\item{annot_data_center_gr}{A GRanges object of width 1}
}
\value{
A vector of log2 distances to the nearest overlap
}
\description{
Helper function used to create (log2) distance type feature space
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/signal_func.R
\name{signal_func}
\alias{signal_func}
\title{Helper function used to create signal type feature space}
\usage{
signal_func(binned_data_gr, annot_data_gr)
}
\arguments{
\item{binned_data_gr}{A GRanges object}

\item{annot_data_gr}{A GRanges object}
}
\value{
A vector of intensities indicating the signal strength within each
overlap
}
\description{
Helper function used to create signal type feature space
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TADrfe.R
\name{TADrfe}
\alias{TADrfe}
\title{A wrapper function passed to \code{caret::rfe} to apply recursive feature
elimination (RFE) on binned domain data as a feature reduction technique for
random forests. Backward elimination is performed from p down to 2, by
powers of 2, where p is the number of features in the data.}
\usage{
TADrfe(
  trainData,
  tuneParams = list(ntree = 500, nodesize = 1),
  cvFolds = 5,
  cvMetric = "Accuracy",
  verbose = FALSE
)
}
\arguments{
\item{trainData}{Data frame, the binned data matrix to built a random forest
classifiers (can be obtained using \code{\link{createTADdata}}). Required.}

\item{tuneParams}{List, providing \code{ntree} and \code{nodesize}
parameters to feed into \code{\link{randomForest}}. Required.}

\item{cvFolds}{Numeric, number of k-fold cross-validation to perform.
Required.}

\item{cvMetric}{Character, performance metric to use to choose optimal
tuning parameters (one of either "Kappa", "Accuracy", "MCC","ROC","Sens",
"Spec", "Pos Pred Value", "Neg Pred Value"). Default is "Accuracy".}

\item{verbose}{Logical, controls whether or not details regarding modeling
should be printed out. Default is TRUE.}
}
\value{
A list containing: 1) the performances extracted at each of the k
folds and, 2) Variable importances among the top features at each step of
RFE. For 1) `Variables` - the best subset of features to consider at each
iteration, `MCC` (Matthews Correlation Coefficient), `ROC` (Area under the
receiver operating characteristic curve), `Sens` (Sensitivity), `Spec`
(Specificity), `Pos Pred Value` (Positive predictive value), `Neg Pred Value`
(Negative predictive value), `Accuracy`, and the corresponding standard
deviations across the cross-folds. For 2) `Overall` - the variable
importance, `var` - the feature name, `Variables` - the number of features
that were considered at each cross-fold, and `Resample` - the cross-fold
}
\description{
A wrapper function passed to \code{caret::rfe} to apply recursive feature
elimination (RFE) on binned domain data as a feature reduction technique for
random forests. Backward elimination is performed from p down to 2, by
powers of 2, where p is the number of features in the data.
}
\examples{
# Read in ARROWHEAD-called TADs at 5kb
data(arrowhead_gm12878_5kb)

#Extract unique boundaries
bounds.GR <- extractBoundaries(domains.mat = arrowhead_gm12878_5kb,
                               filter = FALSE,
                               CHR = "CHR22",
                               resolution = 5000)

# Read in GRangesList of 26 TFBS
data(tfbsList)

# Create the binned data matrix for CHR22 using:
# 5 kb binning,
# oc-type predictors from 26 different TFBS from the GM12878 cell line, and
# random under-sampling
tadData <- createTADdata(bounds.GR = bounds.GR,
                         resolution = 5000,
                         genomicElements.GR = tfbsList,
                         featureType = "oc",
                         resampling = "rus",
                         trainCHR = "CHR22",
                         predictCHR = NULL)

# Perform RFE for fully grown random forests with 100 trees using 5-fold CV
# Evaluate performances using accuracy
rfe_res <- TADrfe(trainData = tadData[[1]],
                  tuneParams = list(ntree = 100, nodesize = 1),
                  cvFolds = 5,
                  cvMetric = "Accuracy",
                  verbose = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tfbsList.R
\docType{data}
\name{tfbsList}
\alias{tfbsList}
\title{A list of the chromosomal coordinates for 26 transcription factor binding
sites from the Gm12878 cell line}
\format{
An object of class \code{CompressedGRangesList} of length 26.
}
\source{
Data obtained from ENCODE.
ENCODE integrative analysis (PMID: 22955616; PMCID: PMC3439153)
ENCODE portal (PMID: 29126249; PMCID: PMC5753278)
Available at
\url{https://www.encodeproject.org/}
}
\usage{
tfbsList
}
\value{
A GrangeList
}
\description{
A GRangesList containing 26 GRanges objects each with the following elements
\describe{
\item{seqnames}{The chromosome number}
\item{ranges}{IRanges object with start and end coordinates for each TFBS}
\item{strand}{empty column}
\item{coverage}{a metadata column with peak strength values at each site}
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/createTADdata.R
\name{createTADdata}
\alias{createTADdata}
\title{Function to create a data matrix used for building a predictive model to
classify boundary regions from functional genomic elements}
\usage{
createTADdata(
  bounds.GR,
  resolution,
  genomicElements.GR,
  featureType = "distance",
  resampling,
  trainCHR,
  predictCHR = NULL,
  genome = "hg19"
)
}
\arguments{
\item{bounds.GR}{a GRanges object with chromosomal coordinates of TAD
boundaries used to identify positive cases (can be obtained using
\code{\link{extractBoundaries}}). Required.}

\item{resolution}{Numeric, the width to bin the genome at, should match the
resolution that TADs were called at. Required.}

\item{genomicElements.GR}{a GRangesList object containing GRanges objects
for each ChIP-seq data to leverage in the random forest model (can be
obtained using the \code{\link{bedToGRangesList}}). Required.}

\item{featureType}{Character, controls how the feature space is constructed
(one of either "binary" (overlap yes/no), "oc" (overlap counts, the number
of overlaps), "op" (overlap percent, the percent of bin width covered by the
genomic annotation), or "distance" (log2-transformed distance from the center
of the nearest genomic annotation to the center of the bin); default is
"distance"). Required.}

\item{resampling}{Character, controls if and how the data should be
resampled to create balanced classes of boundary vs. nonboundary regions (one
of either "none" - no re-sampling, "ros" - Random Over-Sampling, "rus" -
Random Under-Sampling. Required.}

\item{trainCHR}{Character vector of chromosomes to use to build the binned
data matrix for training. Required.}

\item{predictCHR}{Character vector of chromosomes to use to build the binned
data matrix for testing. Default in NULL, indicating no test data is created.
 If trainCHR=predictCHR then a 7:3 split is created.}

\item{genome}{version of the human genome assembly. Used to filter out
bases overlapping centromeric regions. Accepted values - hg19 (default) or 
hg38.}
}
\value{
A list object containing two data.frames: 1) the training data, 2)
the test data (only if predictCHR is not NULL, otherwise it is NA). "y" is
an indicator whether the corresponding bin is a TAD boundary, and the
subsequent columns have the association measures between bins and the
genomic annotations
}
\description{
Function to create a data matrix used for building a predictive model to
classify boundary regions from functional genomic elements
}
\examples{
# Create training data for CHR21 and testing data for CHR22 with
# 5 kb binning, oc-type predictors from 26 different transcription factor
# binding sites from the GM12878 cell line, and random under-sampling

# Read in ARROWHEAD-called TADs at 5kb
data(arrowhead_gm12878_5kb)

#Extract unique boundaries
bounds.GR <- extractBoundaries(domains.mat = arrowhead_gm12878_5kb,
                               filter = FALSE,
                               CHR = c("CHR21", "CHR22"),
                               resolution = 5000)

# Read in GRangesList of 26 TFBS
data(tfbsList)

tadData <- createTADdata(bounds.GR = bounds.GR,
                         resolution = 5000,
                         genomicElements.GR = tfbsList,
                         featureType = "oc",
                         resampling = "rus",
                         trainCHR = "CHR21",
                         predictCHR = "CHR22")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TADrandomForest.R
\name{TADrandomForest}
\alias{TADrandomForest}
\title{A wrapper function passed to \code{caret::train} to apply a random forest
classification algorithm built and tested on user-defined binned domain
data from \code{\link{createTADdata}}.}
\usage{
TADrandomForest(
  trainData,
  testData = NULL,
  tuneParams = list(mtry = ceiling(sqrt(ncol(trainData) - 1)), ntree = 500, nodesize =
    1),
  cvFolds = 3,
  cvMetric = "Accuracy",
  verbose = FALSE,
  model = TRUE,
  importances = TRUE,
  impMeasure = "MDA",
  performances = FALSE
)
}
\arguments{
\item{trainData}{Data frame, the binned data matrix to built a random forest
classifiers (can be obtained using \code{\link{createTADdata}}). Required.}

\item{testData}{Data frame, the binned data matrix to test random forest
classifiers (can be obtained using \code{\link{createTADdata}}). The first
column must be a factor with positive class "Yes". Default is NULL in which
case no performances are evaluated.}

\item{tuneParams}{List, providing \code{mtry}, \code{ntree}, and
\code{nodesize} parameters to feed into \code{\link{randomForest}}. Default
is list(mtry = ceiling(sqrt(ncol(trainData) - 1)), ntree = 500,
nodesize = 1). If multiple values are provided, then a grid search is
performed to tune the model. Required.}

\item{cvFolds}{Numeric, number of k-fold cross-validation to perform in
order to tune the hyperparameters. Required.}

\item{cvMetric}{Character, performance metric to use to choose optimal
tuning parameters (one of either "Kappa", "Accuracy", "MCC", "ROC", "Sens",
"Spec", "Pos Pred Value", "Neg Pred Value"). Default is "Accuracy".}

\item{verbose}{Logical, controls whether or not details regarding modeling
should be printed out. Default is TRUE.}

\item{model}{Logical, whether to keep the model object. Default is TRUE.}

\item{importances}{Logical, whether to extract variable importances. Default
is TRUE.}

\item{impMeasure}{Character, indicates the variable importance measure to
use (one of either "MDA" (mean decrease in accuracy) or "MDG" (mean decrease
in gini)). Ignored if importances = FALSE.}

\item{performances}{Logical, indicates whether various performance metrics
should be extracted when validating the model on the test data. Ignored if
testData = NULL.}
}
\value{
A list containing: 1) a train object from \code{caret} with model
information, 2) a data.frame of variable importance for each feature
included in the model, and 3) a data.frame of various performance metrics
}
\description{
A wrapper function passed to \code{caret::train} to apply a random forest
classification algorithm built and tested on user-defined binned domain
data from \code{\link{createTADdata}}.
}
\examples{
# Read in ARROWHEAD-called TADs at 5kb
data(arrowhead_gm12878_5kb)

# Extract unique boundaries
bounds.GR <- extractBoundaries(domains.mat = arrowhead_gm12878_5kb,
                               filter = FALSE,
                               CHR = c("CHR21", "CHR22"),
                               resolution = 5000)

# Read in GRangesList of 26 TFBS
data(tfbsList)

# Create the binned data matrix for CHR1 (training) and CHR22 (testing)
# using 5 kb binning, distance-type predictors from 26 different TFBS from
# the GM12878 cell line, and random under-sampling
tadData <- createTADdata(bounds.GR = bounds.GR,
                         resolution = 5000,
                         genomicElements.GR = tfbsList,
                         featureType = "distance",
                         resampling = "rus",
                         trainCHR = "CHR21",
                         predictCHR = "CHR22")

# Perform random forest using TADrandomForest by tuning mtry over 10 values
# using 3-fold CV
tadModel <- TADrandomForest(trainData = tadData[[1]],
                            testData = tadData[[2]],
                            tuneParams = list(mtry = c(2,5,8,10,13,16,18,21,24,26),
                                            ntree = 500,
                                            nodesize = 1),
                            cvFolds = 3,
                            cvMetric = "Accuracy",
                            verbose = TRUE,
                            model = TRUE,
                            importances = TRUE,
                            impMeasure = "MDA",
                            performances = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/count_func.R
\name{count_func}
\alias{count_func}
\title{Helper function used to create count overlap type feature space}
\usage{
count_func(binned_data_gr, annot_data_gr)
}
\arguments{
\item{binned_data_gr}{A GRanges object}

\item{annot_data_gr}{A Granges object}
}
\value{
A vector of counts enumerating the number of overlaps
}
\description{
Helper function used to create count overlap type feature space
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binary_func.R
\name{binary_func}
\alias{binary_func}
\title{Helper function used to create binary overlap type feature space}
\usage{
binary_func(binned_data_gr, annot_data_gr)
}
\arguments{
\item{binned_data_gr}{A GRanges object}

\item{annot_data_gr}{A Granges object}
}
\value{
An indicator vector for whether or not an overlap occured
}
\description{
Helper function used to create binary overlap type feature space
}
